
;CodeVisionAVR C Compiler V2.03.9 Standard
;(C) Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATmega8
;Program type           : Application
;Clock frequency        : 4,000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External RAM size      : 0
;Data Stack size        : 128 byte(s)
;Heap size              : 128 byte(s)
;Promote char to int    : No
;char is unsigned       : Yes
;global const stored in FLASH  : Yes
;8 bit enums            : Yes
;Enhanced core instructions    : On
;Smart register allocation : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega8
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1024
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	LDI  R23,BYTE4(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+@1,R0
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _hr=R4
	.DEF _mins=R3
	.DEF _sec=R6
	.DEF _day=R5
	.DEF _B5=R8
	.DEF _C0=R7
	.DEF _H=R10
	.DEF _lat=R9
	.DEF _cor=R12
	.DEF _M=R11
	.DEF _time_mart=R14
	.DEF _time_octb=R13

	.CSEG
	.ORG 0x00

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _timer2_ovf_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _timer0_ovf_isr

_P2:
	.DB  0xDB,0xF,0xC9,0x40
_DR:
	.DB  0x35,0xFA,0x8E,0x3C
_K1:
	.DB  0x82,0x68,0x86,0x3E
_days_month:
	.DB  0x1F,0x1C,0x1F,0x1E,0x1F,0x1E,0x1F,0x1F
	.DB  0x1E,0x1F,0x1E,0x1F
_digits:
	.DB  0x3F,0x6,0x5B,0x4F,0x66,0x6D,0x7D,0x7
	.DB  0x7F,0x6F,0x38,0x54,0x78,0x39,0x5C,0x33
	.DB  0x27,0x76,0x77,0x54,0x5E,0x74,0x50,0x40
	.DB  0x80,0xF7

;DATA STACK END MARKER INITIALIZATION
__DSTACK_END:
	.DB  'D','S','T','A','C','K','E','N','D',0

;HARDWARE STACK END MARKER INITIALIZATION
__HSTACK_END:
	.DB  'H','S','T','A','C','K','E','N','D',0

;HEAP START MARKER INITIALIZATION
__HEAP_START_MARKER:
	.DW  0,0

_0x3:
	.DB  0xD9,0x7
_0x2E:
	.DB  0x1B
_0x2F:
	.DB  0x1D
_0x30:
	.DB  0x1E
_0x31:
	.DB  0x1F
_0x71:
	.DB  0x0,0x0,0x1,0x0,0x0,0x45,0x21,0x3
	.DB  0x3,0x1E
_0x202005F:
	.DB  0x1
_0x2020000:
	.DB  0x2D,0x4E,0x41,0x4E,0x0

__GLOBAL_INI_TBL:
	.DW  0x09
	.DW  0x60
	.DW  __DSTACK_END*2

	.DW  0x09
	.DW  0x00
	.DW  __HSTACK_END*2

	.DW  0x04
	.DW  0x3E0
	.DW  __HEAP_START_MARKER*2

	.DW  0x02
	.DW  _Y
	.DW  _0x3*2

	.DW  0x01
	.DW  _Ok
	.DW  _0x2E*2

	.DW  0x01
	.DW  _Down
	.DW  _0x2F*2

	.DW  0x01
	.DW  _Up
	.DW  _0x30*2

	.DW  0x01
	.DW  _key
	.DW  _0x31*2

	.DW  0x0A
	.DW  0x03
	.DW  _0x71*2

	.DW  0x01
	.DW  __seed_G101
	.DW  _0x202005F*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x380)
	LDI  R25,HIGH(0x380)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x3DF)
	OUT  SPL,R30
	LDI  R30,HIGH(0x3DF)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0xE0)
	LDI  R29,HIGH(0xE0)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0xE0

	.CSEG
;/*****************************************************
;Chip type           : ATmega8
;Program type        : Application
;Clock frequency     : 4,000000 MHz
;Memory model        : Small
;External SRAM size  : 0
;Data Stack size     : 256
;*****************************************************/
;
;#include <mega8.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include <delay.h>
;#include <math.h>
;#include <astro_math.c>
;#include <mega8.h>
;#include <delay.h>
;#include <math.h>
;
;
;const float P2=6.283185308;
;const float DR=0.017453293;
;const float K1=0.262516090;
;
;const unsigned char days_month[12]={31,28,31,30,31,30,31,31,30,31,30,31};
;unsigned char  hr=0, mins=0, sec, day=1, B5=69, C0, H=3, lat=33, cor=30, M=3; //
;
;long int J3, Y=2009;

	.DSEG
;
;long int MM[2], HH[2];
;
;float aA[2], aD[2];
;
;float D, T, T0, TT, A, B, A0, D0, D1, E, F, J, S, L, G, V, U, V0, V1, V2;
;
;bit M8, W8, st, change=0;
;
;unsigned char time_mart, time_octb;
;
;
;// Declare your global variables here
;
;float Abs(float x)
; 0000 000D {

	.CSEG
_Abs:
;  return(x<0?-x:x);
;	x -> Y+0
	RCALL SUBOPT_0x0
	BRPL _0x4
	RCALL SUBOPT_0x1
	RCALL __ANEGF1
	RJMP _0x5
_0x4:
	RCALL SUBOPT_0x1
_0x5:
	RJMP _0x2080006
;}
;
;
;int Sgn(float x)
;{
_Sgn:
;  return(x>=0?1:-1);
;	x -> Y+0
	RCALL SUBOPT_0x0
	BRMI _0x7
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RJMP _0x8
_0x7:
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
_0x8:
	RJMP _0x2080006
;}
;
;long int Trunc (float x)
;{
_Trunc:
;  if (x>=0) {x=floor(x);}
;	x -> Y+0
	RCALL SUBOPT_0x0
	BRMI _0xA
	RCALL SUBOPT_0x2
	RCALL _floor
	RJMP _0x6E
;  else {x=ceil(x);}
_0xA:
	RCALL SUBOPT_0x2
	RCALL _ceil
_0x6E:
	__PUTD1S 0
;  return (long int)x;
	RCALL SUBOPT_0x1
	RCALL __CFD1
_0x2080006:
	ADIW R28,4
	RET
;}
;
;
;void Calendar(void)
;{
_Calendar:
;  D1 = Trunc(D);
	RCALL SUBOPT_0x3
	RCALL SUBOPT_0x4
	LDI  R26,LOW(_D1)
	LDI  R27,HIGH(_D1)
	RCALL __CDF1
	RCALL __PUTDP1
;  F = D - D1 - 0.5;
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x3
	RCALL __SUBF12
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0x9
;  J = -Trunc(1.75 * (Trunc((M + 9.0) / 12) + Y));
	RCALL SUBOPT_0xA
	__GETD2N 0x41100000
	RCALL SUBOPT_0xB
	__GETD1N 0x41400000
	RCALL __DIVF21
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0xC
	RCALL __ADDD12
	RCALL __CDF1
	__GETD2N 0x3FE00000
	RCALL __MULF12
	RCALL SUBOPT_0x4
	RCALL __ANEGD1
	LDI  R26,LOW(_J)
	LDI  R27,HIGH(_J)
	RCALL __CDF1
	RCALL SUBOPT_0xD
;  S = Sgn(M - 9);
	RCALL _Sgn
	LDI  R26,LOW(_S)
	LDI  R27,HIGH(_S)
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0xD
;  J3 = Trunc(Y + S * Trunc(Abs(M - 9)/7));
	RCALL _Abs
	RCALL SUBOPT_0x6
	__GETD1N 0x40E00000
	RCALL __DIVF21
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0xF
	RCALL __CDF1
	RCALL __MULF12
	RCALL SUBOPT_0xC
	RCALL __CDF2
	RCALL __ADDF12
	RCALL SUBOPT_0x4
	STS  _J3,R30
	STS  _J3+1,R31
	STS  _J3+2,R22
	STS  _J3+3,R23
;  J3 =( -(((J3 / 100) + 1) * 0.75));
	LDS  R26,_J3
	LDS  R27,_J3+1
	LDS  R24,_J3+2
	LDS  R25,_J3+3
	__GETD1N 0x64
	RCALL __DIVD21
	__ADDD1N 1
	RCALL __CDF1
	__GETD2N 0x3F400000
	RCALL __MULF12
	RCALL __ANEGF1
	LDI  R26,LOW(_J3)
	LDI  R27,HIGH(_J3)
	RCALL __CFD1
	RCALL __PUTDP1
;  J = J + Trunc(30.555555556 * M ) + D1 + J3;
	RCALL SUBOPT_0xA
	__GETD2N 0x41F471C7
	RCALL __MULF12
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x10
	RCALL __CDF1
	RCALL __ADDF12
	RCALL SUBOPT_0x5
	RCALL __ADDF12
	MOVW R26,R30
	MOVW R24,R22
	LDS  R30,_J3
	LDS  R31,_J3+1
	LDS  R22,_J3+2
	LDS  R23,_J3+3
	RCALL SUBOPT_0x11
;  J = J + 1721029 + 367 * Y;
	LDS  R30,_J
	LDS  R31,_J+1
	LDS  R22,_J+2
	LDS  R23,_J+3
	__GETD2N 0x49D21628
	RCALL __ADDF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x12
	__GETD2N 0x16F
	RCALL __MULD12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	RCALL SUBOPT_0x11
;  if (F >= 0) {return;};
	LDS  R26,_F+3
	TST  R26
	BRMI _0xC
	RET
_0xC:
;  F = F + 1;
	LDS  R30,_F
	LDS  R31,_F+1
	LDS  R22,_F+2
	LDS  R23,_F+3
	RCALL SUBOPT_0x13
	RCALL __ADDF12
	RCALL SUBOPT_0x9
;  J = J - 1;
	RCALL SUBOPT_0x10
	RCALL SUBOPT_0x14
	RCALL SUBOPT_0x8
	STS  _J,R30
	STS  _J+1,R31
	STS  _J+2,R22
	STS  _J+3,R23
;}
	RET
;
;void GetTimeZone(void)
;{
_GetTimeZone:
;  S = 24110.5 + 236.555367912 * T;
	RCALL SUBOPT_0x15
	__GETD2N 0x436C8E2D
	RCALL __MULF12
	__GETD2N 0x46BC5D00
	RCALL SUBOPT_0x16
;  S = S -(3609.858333333 * (float) H) + 240.0 * lat;
	RCALL SUBOPT_0x17
	__GETD2N 0x45619DBC
	RCALL SUBOPT_0x18
	RCALL SUBOPT_0x8
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	MOV  R30,R9
	RCALL SUBOPT_0x19
	__GETD2N 0x43700000
	RCALL __MULF12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	RCALL SUBOPT_0x16
;  S = S / 86400;
	RCALL SUBOPT_0xF
	__GETD1N 0x47A8C000
	RCALL SUBOPT_0x1A
;  S = S - Trunc(S);
	RCALL SUBOPT_0x1B
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0xF
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0x1D
;  T0 = S * 360 * DR;
	RCALL SUBOPT_0xF
	__GETD1N 0x43B40000
	RCALL __MULF12
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x1E
	RCALL __MULF12
	STS  _T0,R30
	STS  _T0+1,R31
	STS  _T0+2,R22
	STS  _T0+3,R23
;}
	RET
;
;float GetAtan()
;{
_GetAtan:
;  return atan(S / sqrt(1 - S * S));
	RCALL SUBOPT_0x1B
	RCALL SUBOPT_0xF
	RCALL __MULF12
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x8
	RCALL __PUTPARD1
	RCALL _sqrt
	RCALL SUBOPT_0xF
	RCALL SUBOPT_0x1F
	RCALL _atan
	RET
;}
;
;
;void PosOfSun(char ind)
;{
_PosOfSun:
;
;  //       
;  //  (Van Flandern & Pulkkinen, 1979)
;  L = 0.779072 + 0.00273790931 * T;
;	ind -> Y+0
	RCALL SUBOPT_0x15
	__GETD2N 0x3B336E7F
	RCALL __MULF12
	__GETD2N 0x3F477143
	RCALL SUBOPT_0x20
;  G = 0.993126 + 0.0027377785 * T;
	RCALL SUBOPT_0x15
	__GETD2N 0x3B336C4D
	RCALL __MULF12
	__GETD2N 0x3F7E3D81
	RCALL SUBOPT_0x21
;  L = L - Trunc(L);
	RCALL SUBOPT_0x22
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x23
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0x24
;  G = G - Trunc(G);
	RCALL SUBOPT_0x25
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x26
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0x27
;  L = L * P2;
	RCALL SUBOPT_0x28
	RCALL SUBOPT_0x23
	RCALL __MULF12
	RCALL SUBOPT_0x24
;  G = G * P2;
	RCALL SUBOPT_0x28
	RCALL SUBOPT_0x26
	RCALL __MULF12
	RCALL SUBOPT_0x27
;  V = 0.39785 * sin(L);
	RCALL SUBOPT_0x22
	RCALL SUBOPT_0x29
	__GETD2N 0x3ECBB2FF
	RCALL __MULF12
	RCALL SUBOPT_0x2A
;  V = V - 0.01000 * sin(L - G);
	RCALL SUBOPT_0x26
	RCALL SUBOPT_0x22
	RCALL __SUBF12
	RCALL SUBOPT_0x29
	__GETD2N 0x3C23D70A
	RCALL SUBOPT_0x2B
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0x2A
;  V = V + 0.00333 * sin(L + G);
	RCALL SUBOPT_0x25
	RCALL SUBOPT_0x23
	RCALL __ADDF12
	RCALL SUBOPT_0x29
	__GETD2N 0x3B5A3C21
	RCALL SUBOPT_0x2B
	RCALL __ADDF12
	RCALL SUBOPT_0x2A
;  V = V - 0.00021 * TT * sin(L);
	RCALL SUBOPT_0x2C
	__GETD2N 0x395C3372
	RCALL __MULF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x22
	RCALL SUBOPT_0x29
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	RCALL SUBOPT_0x2B
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0x2A
;  U = 1 - 0.03349 * cos(G);
	RCALL SUBOPT_0x25
	RCALL SUBOPT_0x2D
	__GETD2N 0x3D092CCF
	RCALL __MULF12
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0x2E
;  U = U - 0.00014 * cos(2 * L);
	RCALL SUBOPT_0x2F
	RCALL SUBOPT_0x2D
	__GETD2N 0x3912CCF7
	RCALL SUBOPT_0x30
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0x2E
;  U = U + 0.00008 * cos(L);
	RCALL SUBOPT_0x2D
	RCALL SUBOPT_0x31
	RCALL SUBOPT_0x30
	RCALL __ADDF12
	RCALL SUBOPT_0x2E
;  S = -0.00010 - 0.04129 * sin(2 * L);
	RCALL SUBOPT_0x2F
	RCALL SUBOPT_0x29
	__GETD2N 0x3D291FB4
	RCALL __MULF12
	__GETD2N 0xB8D1B717
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0x1D
;  S = S + 0.03211 * sin(G);
	RCALL SUBOPT_0x25
	RCALL SUBOPT_0x29
	__GETD2N 0x3D0385C6
	RCALL SUBOPT_0x18
	RCALL SUBOPT_0x16
;  S = S + 0.00104 * sin(2 * L - G);
	RCALL SUBOPT_0x22
	RCALL SUBOPT_0x2F
	RCALL SUBOPT_0x26
	RCALL __SUBF12
	RCALL SUBOPT_0x29
	__GETD2N 0x3A88509C
	RCALL SUBOPT_0x18
	RCALL SUBOPT_0x16
;  S = S - 0.00035 * sin(2 * L + G);
	RCALL SUBOPT_0x22
	RCALL SUBOPT_0x2F
	RCALL SUBOPT_0x26
	RCALL __ADDF12
	RCALL SUBOPT_0x29
	__GETD2N 0x39B78034
	RCALL SUBOPT_0x18
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0x1D
;  S = S - 0.00008 * TT * sin(G);
	RCALL SUBOPT_0x2C
	RCALL SUBOPT_0x31
	RCALL __MULF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x25
	RCALL SUBOPT_0x29
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	RCALL SUBOPT_0x18
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0x1D
;  S = S / sqrt(U - V * V);
	LDS  R30,_V
	LDS  R31,_V+1
	LDS  R22,_V+2
	LDS  R23,_V+3
	RCALL SUBOPT_0x32
	RCALL SUBOPT_0x30
	RCALL SUBOPT_0x8
	RCALL __PUTPARD1
	RCALL _sqrt
	RCALL SUBOPT_0xF
	RCALL SUBOPT_0x1A
;  aA[ind] = L + GetAtan();
	LD   R30,Y
	LDI  R26,LOW(_aA)
	LDI  R27,HIGH(_aA)
	RCALL SUBOPT_0x33
	PUSH R31
	PUSH R30
	RCALL _GetAtan
	RCALL SUBOPT_0x23
	RCALL __ADDF12
	POP  R26
	POP  R27
	RCALL __PUTDP1
;  S = V / sqrt(U);
	LDS  R30,_U
	LDS  R31,_U+1
	LDS  R22,_U+2
	LDS  R23,_U+3
	RCALL __PUTPARD1
	RCALL _sqrt
	RCALL SUBOPT_0x32
	RCALL SUBOPT_0x1A
;  aD[ind] = GetAtan();
	LD   R30,Y
	LDI  R26,LOW(_aD)
	LDI  R27,HIGH(_aD)
	RCALL SUBOPT_0x33
	PUSH R31
	PUSH R30
	RCALL _GetAtan
	POP  R26
	POP  R27
	RCALL __PUTDP1
;}
	ADIW R28,1
	RET
;
;float getV(float vd, float vh)
;{
_getV:
;  return (S * sin(vd) + cos(B5 * DR)* cos(vd) * cos(vh) - cos(DR * 90.833));
;	vd -> Y+4
;	vh -> Y+0
	RCALL SUBOPT_0x34
	RCALL SUBOPT_0x29
	RCALL SUBOPT_0xF
	RCALL __MULF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x1E
	RCALL SUBOPT_0x35
	RCALL SUBOPT_0x2D
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x34
	RCALL SUBOPT_0x2D
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	RCALL __MULF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x2
	RCALL _cos
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	RCALL __MULF12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	RCALL __ADDF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x1E
	__GETD2N 0x42B5AA7F
	RCALL __MULF12
	RCALL SUBOPT_0x2D
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	RCALL SUBOPT_0x8
	RJMP _0x2080002
;}
;
;void PossibleEvents(int Hour)
;{
_PossibleEvents:
;  L = aA[0] + ((float)Hour + 1) / 24 * (aA[1] - aA[0]);
;	Hour -> Y+0
	RCALL SUBOPT_0x36
	RCALL SUBOPT_0x37
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	__GETD1MN _aA,4
	RCALL SUBOPT_0x38
	RCALL __SUBF12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	RCALL __MULF12
	RCALL SUBOPT_0x38
	RCALL SUBOPT_0x20
;  G = aD[0] + ((float)Hour + 1) / 24 * (aD[1] - aD[0]);
	RCALL SUBOPT_0x36
	RCALL SUBOPT_0x37
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	__GETD1MN _aD,4
	RCALL SUBOPT_0x39
	RCALL __SUBF12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	RCALL __MULF12
	RCALL SUBOPT_0x39
	RCALL SUBOPT_0x21
;  st = 0;
	CLT
	BLD  R2,2
;  A = T0 + Hour * K1 - A0;
	RCALL SUBOPT_0x3A
	RCALL __ADDF12
	LDS  R26,_A0
	LDS  R27,_A0+1
	LDS  R24,_A0+2
	LDS  R25,_A0+3
	RCALL __SUBF12
	RCALL SUBOPT_0x3B
;  B = T0 + Hour * K1 + K1 - L;
	RCALL SUBOPT_0x3A
	RCALL SUBOPT_0xB
	LDI  R30,LOW(_K1*2)
	LDI  R31,HIGH(_K1*2)
	RCALL __GETD1PF
	RCALL __ADDF12
	RCALL SUBOPT_0x23
	RCALL SUBOPT_0x3C
;  if (Hour <= 0) {V0 = getV(D0, A);}
	LD   R26,Y
	LDD  R27,Y+1
	RCALL __CPW02
	BRLT _0xD
	RCALL SUBOPT_0x3D
	RCALL __PUTPARD1
	RCALL SUBOPT_0x3E
	RCALL __PUTPARD1
	RCALL _getV
	RCALL SUBOPT_0x3F
;  V2 = getV(G,B);
_0xD:
	RCALL SUBOPT_0x25
	RCALL __PUTPARD1
	RCALL SUBOPT_0x40
	RCALL __PUTPARD1
	RCALL _getV
	STS  _V2,R30
	STS  _V2+1,R31
	STS  _V2+2,R22
	STS  _V2+3,R23
;  if (Sgn(V0) == Sgn(V2)) {goto end2;}
	RCALL SUBOPT_0x41
	RCALL __PUTPARD1
	RCALL _Sgn
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x42
	RCALL __PUTPARD1
	RCALL _Sgn
	POP  R26
	POP  R27
	CP   R30,R26
	CPC  R31,R27
	BRNE _0xE
	RJMP _0xF
;  V1 = getV((G + D0) / 2,(B + A) / 2);
_0xE:
	RCALL SUBOPT_0x3D
	RCALL SUBOPT_0x26
	RCALL SUBOPT_0xB
	RCALL SUBOPT_0x43
	RCALL SUBOPT_0x3E
	RCALL SUBOPT_0x44
	RCALL SUBOPT_0xB
	RCALL SUBOPT_0x43
	RCALL _getV
	STS  _V1,R30
	STS  _V1+1,R31
	STS  _V1+2,R22
	STS  _V1+3,R23
;  A = 2 * V2 - 4 * V1 + 2 * V0;
	RCALL SUBOPT_0x42
	RCALL SUBOPT_0x2F
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x45
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	RCALL SUBOPT_0x8
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x41
	RCALL SUBOPT_0x2F
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	RCALL __ADDF12
	RCALL SUBOPT_0x3B
;  B = 4 * V1 - 3 * V0 - V2;
	RCALL SUBOPT_0x45
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x41
	__GETD2N 0x40400000
	RCALL __MULF12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0x46
	RCALL SUBOPT_0x3C
;  D = B * B - 4 * A * V0;
	RCALL SUBOPT_0x40
	RCALL SUBOPT_0x44
	RCALL __MULF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x3E
	__GETD2N 0x40800000
	RCALL __MULF12
	RCALL SUBOPT_0x47
	RCALL __MULF12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0x48
;  if (D < 0) {goto end2;};
	LDS  R26,_D+3
	TST  R26
	BRPL _0x10
	RJMP _0xF
_0x10:
;  D = sqrt(D);
	RCALL SUBOPT_0x3
	RCALL __PUTPARD1
	RCALL _sqrt
	RCALL SUBOPT_0x48
;  E = (-B + D) / (2 * A);
	RCALL SUBOPT_0x49
	RCALL __ADDF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x3E
	RCALL SUBOPT_0x2F
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	RCALL SUBOPT_0x4A
;  if ((E > 1) || (E < 0)) {E = (-B - D) / (2 * A);}
	LDS  R26,_E
	LDS  R27,_E+1
	LDS  R24,_E+2
	LDS  R25,_E+3
	RCALL SUBOPT_0x14
	RCALL __CMPF12
	BREQ PC+3
	BRCS PC+2
	RJMP _0x12
	LDS  R26,_E+3
	TST  R26
	BRPL _0x11
_0x12:
	RCALL SUBOPT_0x49
	RCALL __SUBF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x3E
	RCALL SUBOPT_0x2F
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	RCALL SUBOPT_0x4A
;  A = (Hour + E + 1 / 120 );
_0x11:
	LDS  R30,_E
	LDS  R31,_E+1
	LDS  R22,_E+2
	LDS  R23,_E+3
	LD   R26,Y
	LDD  R27,Y+1
	RCALL __CWD2
	RCALL __CDF2
	RCALL __ADDF12
	__GETD2N 0x0
	RCALL __ADDF12
	RCALL SUBOPT_0x3B
;  B = Trunc((A - Trunc(A)) * 60); //M3
	RCALL SUBOPT_0x3E
	RCALL SUBOPT_0x4
	LDS  R26,_A
	LDS  R27,_A+1
	LDS  R24,_A+2
	LDS  R25,_A+3
	RCALL SUBOPT_0x1C
	__GETD2N 0x42700000
	RCALL __MULF12
	RCALL SUBOPT_0x4
	LDI  R26,LOW(_B)
	LDI  R27,HIGH(_B)
	RCALL __CDF1
	RCALL __PUTDP1
;  if ((V0 < 0) && (V2 > 0)) {HH[0]=Trunc(A);  MM[0]=Trunc(B);  M8 = 1; st=1;};
	LDS  R26,_V0+3
	TST  R26
	BRPL _0x15
	RCALL SUBOPT_0x46
	RCALL __CPD02
	BRLT _0x16
_0x15:
	RJMP _0x14
_0x16:
	RCALL SUBOPT_0x3E
	RCALL SUBOPT_0x4
	STS  _HH,R30
	STS  _HH+1,R31
	STS  _HH+2,R22
	STS  _HH+3,R23
	RCALL SUBOPT_0x40
	RCALL SUBOPT_0x4
	STS  _MM,R30
	STS  _MM+1,R31
	STS  _MM+2,R22
	STS  _MM+3,R23
	SET
	BLD  R2,0
	RCALL SUBOPT_0x4B
_0x14:
;  if ((V0 > 0) && (V2 < 0)) {HH[1]=Trunc(A);  MM[1]=Trunc(B);  W8 = 1; st=1;};
	RCALL SUBOPT_0x47
	RCALL __CPD02
	BRGE _0x18
	LDS  R26,_V2+3
	TST  R26
	BRMI _0x19
_0x18:
	RJMP _0x17
_0x19:
	RCALL SUBOPT_0x3E
	RCALL SUBOPT_0x4
	__PUTD1MN _HH,4
	RCALL SUBOPT_0x40
	RCALL SUBOPT_0x4
	__PUTD1MN _MM,4
	SET
	BLD  R2,1
	RCALL SUBOPT_0x4B
_0x17:
;end2:
_0xF:
;  A0 = L;
	RCALL SUBOPT_0x22
	RCALL SUBOPT_0x4C
;  D0 = G;
	RCALL SUBOPT_0x25
	RCALL SUBOPT_0x4D
;  V0 = V2;
	RCALL SUBOPT_0x42
	RCALL SUBOPT_0x3F
;}
	ADIW R28,2
	RET
;
;
;void OutInform(void)
;{
_OutInform:
;  if ((M8 == 0) && (W8 == 0))
	LDI  R26,0
	SBRC R2,0
	LDI  R26,1
	CPI  R26,LOW(0x0)
	BRNE _0x1B
	LDI  R26,0
	SBRC R2,1
	LDI  R26,1
	CPI  R26,LOW(0x0)
	BREQ _0x1C
_0x1B:
	RJMP _0x1A
_0x1C:
; {
;    if (V2 < 0) {st=1;}//   
	LDS  R26,_V2+3
	TST  R26
	BRPL _0x1D
	RCALL SUBOPT_0x4B
;    if (V2 > 0) {st=0;}//   
_0x1D:
	RCALL SUBOPT_0x46
	RCALL __CPD02
	BRGE _0x1E
	CLT
	BLD  R2,2
; }
_0x1E:
;  else
	RJMP _0x1F
_0x1A:
;  {
;    if (M8 == 0) {st=1;} //     
	SBRS R2,0
	RCALL SUBOPT_0x4B
;    if (W8 == 0) {st=0;} //     
	SBRC R2,1
	RJMP _0x21
	CLT
	BLD  R2,2
;  }
_0x21:
_0x1F:
;}
	RET
;
;char Get_Day(int _day, int _month)//   ,   0- 1- ...
;{
_Get_Day:
;  int a, y, m;
;  a = (14 - _month) / 12;
	RCALL __SAVELOCR6
;	_day -> Y+8
;	_month -> Y+6
;	a -> R16,R17
;	y -> R18,R19
;	m -> R20,R21
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LDI  R30,LOW(14)
	LDI  R31,HIGH(14)
	SUB  R30,R26
	SBC  R31,R27
	RCALL SUBOPT_0x4E
	MOVW R16,R30
;  y = Y - a;
	MOVW R30,R16
	RCALL SUBOPT_0xC
	RCALL __CWD1
	RCALL __SWAPD12
	RCALL __SUBD12
	MOVW R18,R30
;  m = _month + 12 * a - 2;
	MOVW R30,R16
	LDI  R26,LOW(12)
	LDI  R27,HIGH(12)
	RCALL __MULW12
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADD  R26,R30
	ADC  R27,R31
	SBIW R26,2
	MOVW R20,R26
;  return (7000 + (_day + y + y / 4 - y / 100 + y / 400 + (31 * m) / 12)) % 7;
	MOVW R30,R18
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	ADD  R30,R26
	ADC  R31,R27
	MOVW R22,R30
	MOVW R26,R18
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	RCALL __DIVW21
	__ADDWRR 22,23,30,31
	MOVW R26,R18
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RCALL __DIVW21
	__SUBWRR 22,23,30,31
	MOVW R26,R18
	LDI  R30,LOW(400)
	LDI  R31,HIGH(400)
	RCALL __DIVW21
	__ADDWRR 22,23,30,31
	MOVW R30,R20
	LDI  R26,LOW(31)
	LDI  R27,HIGH(31)
	RCALL __MULW12
	RCALL SUBOPT_0x4E
	MOVW R26,R22
	ADD  R26,R30
	ADC  R27,R31
	SUBI R26,LOW(-7000)
	SBCI R27,HIGH(-7000)
	LDI  R30,LOW(7)
	LDI  R31,HIGH(7)
	RCALL __MODW21
	RCALL __LOADLOCR6
	RJMP _0x2080004
;};
;
;void show_info(void)
;{
_show_info:
;  D = day;
	MOV  R30,R5
	LDI  R26,LOW(_D)
	LDI  R27,HIGH(_D)
	RCALL SUBOPT_0x19
	RCALL __PUTDP1
;  Calendar();
	RCALL _Calendar
;  T = (J - 2451545) + F;
	RCALL SUBOPT_0x10
	__GETD1N 0x4A15A164
	RCALL SUBOPT_0x8
	LDS  R26,_F
	LDS  R27,_F+1
	LDS  R24,_F+2
	LDS  R25,_F+3
	RCALL SUBOPT_0x4F
;  TT = T / 36525 + 1; // TT - ,   1900
	RCALL SUBOPT_0x50
	__GETD1N 0x470EAD00
	RCALL __DIVF21
	RCALL SUBOPT_0x13
	RCALL __ADDF12
	STS  _TT,R30
	STS  _TT+1,R31
	STS  _TT+2,R22
	STS  _TT+3,R23
;  GetTimeZone(); //   
	RCALL _GetTimeZone
;  T = T - (float) H / 24;
	RCALL SUBOPT_0x17
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x37
	RCALL SUBOPT_0x50
	RCALL SUBOPT_0x8
	STS  _T,R30
	STS  _T+1,R31
	STS  _T+2,R22
	STS  _T+3,R23
;  PosOfSun(0); //   
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _PosOfSun
;  T = T + 1;
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x4F
;  PosOfSun(1);
	RCALL SUBOPT_0x51
	RCALL _PosOfSun
;  if (aA[1] < aA[0]) {aA[1] = aA[1] + P2;}
	RCALL SUBOPT_0x52
	RCALL SUBOPT_0x53
	RCALL __CMPF12
	BRSH _0x22
	RCALL SUBOPT_0x52
	RCALL SUBOPT_0x28
	RCALL __ADDF12
	__PUTD1MN _aA,4
;  S = sin(B5 * DR);
_0x22:
	RCALL SUBOPT_0x1E
	RCALL SUBOPT_0x35
	RCALL SUBOPT_0x29
	RCALL SUBOPT_0x1D
;  M8 = 0;
	CLT
	BLD  R2,0
;  W8 = 0;
	BLD  R2,1
;  A0 = aA[0];
	RCALL SUBOPT_0x53
	RCALL SUBOPT_0x4C
;  D0 = aD[0];
	LDS  R30,_aD
	LDS  R31,_aD+1
	LDS  R22,_aD+2
	LDS  R23,_aD+3
	RCALL SUBOPT_0x4D
;  for (C0 = 0; C0 < 24; C0++) {PossibleEvents(C0);}
	CLR  R7
_0x24:
	LDI  R30,LOW(24)
	CP   R7,R30
	BRSH _0x25
	RCALL SUBOPT_0x54
	RCALL _PossibleEvents
	INC  R7
	RJMP _0x24
_0x25:
;  OutInform();
	RCALL _OutInform
;  for (C0 = 25; C0 < 32; C0++)
	LDI  R30,LOW(25)
	MOV  R7,R30
_0x27:
	LDI  R30,LOW(32)
	CP   R7,R30
	BRSH _0x28
;  {
;    if (Get_Day(C0,3)==0) {time_mart=C0;};
	RCALL SUBOPT_0x54
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	RCALL SUBOPT_0x55
	BRNE _0x29
	MOV  R14,R7
_0x29:
;  }
	INC  R7
	RJMP _0x27
_0x28:
;  for (C0 = 25; C0 < 32; C0++)
	LDI  R30,LOW(25)
	MOV  R7,R30
_0x2B:
	LDI  R30,LOW(32)
	CP   R7,R30
	BRSH _0x2C
;  {
;    if (Get_Day(C0,10)==0) {time_octb=C0;};
	RCALL SUBOPT_0x54
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL SUBOPT_0x55
	BRNE _0x2D
	MOV  R13,R7
_0x2D:
;  }
	INC  R7
	RJMP _0x2B
_0x2C:
;}
	RET
;
;
;
;// Declare your global variables here
;#define light_on  PORTC.5=1;
;#define light_off PORTC.5=0;
;
;
;unsigned char Ok=27, Down=29, Up=30, key=31;

	.DSEG
;
;
;
;flash char digits[] = {
;0b00111111,                   //0 0
;0b00000110,                   //1  1
;0b01011011,                   //2  2
;0b01001111,                   //3  3
;0b01100110,                   //4  4
;0b01101101,                   //5  5
;0b01111101,                   //6  6
;0b00000111,                   //7  7
;0b01111111,                   //8  8
;0b01101111,                   //9  9
;0b00111000,                   //L  10
;0b01010100,                   //n  11
;0b01111000,                   //t  12
;0b00111001,                   //C  13
;0b01011100,                   //o  14
;0b00110011,                   //M  15
;0b00100111,                   //M  16
;0b01110110,                   //H  17
;0b01110111,                   //R  18
;0b01010100,                   //m  19
;//hgfedcba                         00
;0b01011110,                   //d  20
;0b01110100,                   //h  21
;0b01010000,                   //r  22
;0b01000000,                   //-  23
;0b10000000,                   //.  24
;0b11110111                   // A. 25
;};
;
;
;// Declare your global variables here
;
;unsigned char digit_buff[4];
;
;// Timer 0 overflow interrupt service routine
;interrupt [TIM0_OVF] void timer0_ovf_isr(void)
; 0000 003E {

	.CSEG
_timer0_ovf_isr:
	ST   -Y,R30
	IN   R30,SREG
	ST   -Y,R30
; 0000 003F // Place your code here
; 0000 0040     key=PINC & 0b00011111;// 
	RCALL SUBOPT_0x56
; 0000 0041 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R30,Y+
	RETI
;
;// Timer 2 overflow interrupt service routine
;interrupt [TIM2_OVF] void timer2_ovf_isr(void)
; 0000 0045 {
_timer2_ovf_isr:
	ST   -Y,R30
	IN   R30,SREG
; 0000 0046 // Place your code here
; 0000 0047   sec++; //  
	INC  R6
; 0000 0048 }
	OUT  SREG,R30
	LD   R30,Y+
	RETI
;
;
;void me_delay(void)
; 0000 004C {
_me_delay:
; 0000 004D   while (key!=31) {key=PINC & 0b00011111; delay_ms(10);};
_0x32:
	RCALL SUBOPT_0x57
	CPI  R26,LOW(0x1F)
	BREQ _0x34
	RCALL SUBOPT_0x56
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL SUBOPT_0x58
	RJMP _0x32
_0x34:
; 0000 004E }
	RET
;
;
;// Declare your global variables here
;
;void display(void)
; 0000 0054 {
_display:
; 0000 0055   PORTB=0b00011100;
	LDI  R30,LOW(28)
	OUT  0x18,R30
; 0000 0056   PORTD=digit_buff[0];
	LDS  R30,_digit_buff
	RCALL SUBOPT_0x59
; 0000 0057   delay_ms(8);
; 0000 0058 
; 0000 0059   PORTB=0b00011010;
	LDI  R30,LOW(26)
	OUT  0x18,R30
; 0000 005A   PORTD=digit_buff[1];
	__GETB1MN _digit_buff,1
	RCALL SUBOPT_0x59
; 0000 005B   delay_ms(8);
; 0000 005C 
; 0000 005D   PORTB=0b00010110;
	LDI  R30,LOW(22)
	OUT  0x18,R30
; 0000 005E   PORTD=digit_buff[2];
	__GETB1MN _digit_buff,2
	RCALL SUBOPT_0x59
; 0000 005F   delay_ms(8);
; 0000 0060 
; 0000 0061   PORTB=0b00001110;
	LDI  R30,LOW(14)
	OUT  0x18,R30
; 0000 0062   PORTD=digit_buff[3];
	__GETB1MN _digit_buff,3
	RCALL SUBOPT_0x59
; 0000 0063   delay_ms(8);
; 0000 0064 }
	RET
;
;
;void sun_up(void)
; 0000 0068 {
_sun_up:
; 0000 0069   digit_buff[0]=digits[HH[0]/10%10];
	RCALL SUBOPT_0x5A
	RCALL SUBOPT_0x5B
	RCALL SUBOPT_0x5C
; 0000 006A   digit_buff[1]=digits[HH[0]%10];
	RCALL SUBOPT_0x5A
	RCALL SUBOPT_0x5D
	RCALL SUBOPT_0x5E
; 0000 006B   digit_buff[2]=digits[MM[0]/10%10];
	RCALL SUBOPT_0x5F
	RCALL SUBOPT_0x5B
	RCALL SUBOPT_0x60
; 0000 006C   digit_buff[3]=digits[MM[0]%10];
	RCALL SUBOPT_0x5F
	RCALL SUBOPT_0x5D
	RCALL SUBOPT_0x61
; 0000 006D   display();
	RJMP _0x2080003
; 0000 006E }
;
;
;void sun_dn(void)
; 0000 0072 {
_sun_dn:
; 0000 0073   digit_buff[0]=digits[HH[1]/10%10];
	RCALL SUBOPT_0x62
	RCALL SUBOPT_0x5B
	RCALL SUBOPT_0x5C
; 0000 0074   digit_buff[1]=digits[HH[1]%10];
	RCALL SUBOPT_0x62
	RCALL SUBOPT_0x5D
	RCALL SUBOPT_0x5E
; 0000 0075   digit_buff[2]=digits[MM[1]/10%10];
	RCALL SUBOPT_0x63
	RCALL SUBOPT_0x5B
	RCALL SUBOPT_0x60
; 0000 0076   digit_buff[3]=digits[MM[1]%10];
	RCALL SUBOPT_0x63
	RCALL SUBOPT_0x5D
	RCALL SUBOPT_0x61
; 0000 0077   display();
	RJMP _0x2080003
; 0000 0078 }
;
; void recode_time(void)
; 0000 007B  {
_recode_time:
; 0000 007C    digit_buff[0]=digits[(hr/10)%10];
	MOV  R26,R4
	RCALL SUBOPT_0x64
	RCALL SUBOPT_0x5C
; 0000 007D    digit_buff[1]=digits[hr%10];
	MOV  R26,R4
	RCALL SUBOPT_0x65
	RCALL SUBOPT_0x5E
; 0000 007E    digit_buff[2]=digits[(mins/10)%10];
	MOV  R26,R3
	RCALL SUBOPT_0x64
	RCALL SUBOPT_0x60
; 0000 007F    digit_buff[3]=digits[mins%10];
	MOV  R26,R3
	RCALL SUBOPT_0x65
	RCALL SUBOPT_0x61
; 0000 0080  }
	RET
;
;
;void sun_info()
; 0000 0084 {
; 0000 0085 /*  lcd_gotoxy(0,0);
; 0000 0086   lcd_putchar (HH[0]/10%10+0x30);
; 0000 0087   lcd_putchar (HH[0]%10+0x30);
; 0000 0088   lcd_putchar (':');
; 0000 0089   lcd_putchar (MM[0]/10%10+0x30);
; 0000 008A   lcd_putchar (MM[0]%10+0x30);
; 0000 008B   lcd_putchar (' ');
; 0000 008C   lcd_putchar (HH[1]/10%10+0x30);
; 0000 008D   lcd_putchar (HH[1]%10+0x30);
; 0000 008E   lcd_putchar (':');
; 0000 008F   lcd_putchar (MM[1]/10%10+0x30);
; 0000 0090   lcd_putchar (MM[1]%10+0x30);*/
; 0000 0091 }
;
;
;void clock(void)
; 0000 0095 { unsigned char qty_days;
_clock:
; 0000 0096 //  if (sec%2==0) {DP=1;} else {DP=0;};
; 0000 0097   if (sec==60) //   60
	ST   -Y,R17
;	qty_days -> R17
	LDI  R30,LOW(60)
	CP   R30,R6
	BRNE _0x35
; 0000 0098   {
; 0000 0099     sec=0;
	CLR  R6
; 0000 009A     mins++;
	INC  R3
; 0000 009B   } else
	RJMP _0x36
_0x35:
; 0000 009C   {
; 0000 009D     return; //,       
	RJMP _0x2080005
; 0000 009E   };
_0x36:
; 0000 009F   if (mins==60) {mins=0; hr++;};//   60
	LDI  R30,LOW(60)
	CP   R30,R3
	BRNE _0x37
	CLR  R3
	INC  R4
_0x37:
; 0000 00A0   if (hr==24) {day++; hr=0; show_info();};//   24
	LDI  R30,LOW(24)
	CP   R30,R4
	BRNE _0x38
	INC  R5
	CLR  R4
	RCALL _show_info
_0x38:
; 0000 00A1   qty_days=days_month[M-1];//   
	RCALL SUBOPT_0x66
	LPM  R17,Z
; 0000 00A2   if ((M==2) && (Y%4)==(Y/4)) {qty_days = 29;}//   
	LDI  R30,LOW(2)
	CP   R30,R11
	BRNE _0x3A
	RCALL SUBOPT_0x67
	RCALL __MODD21
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x67
	RCALL __DIVD21
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	RCALL __CPD12
	BREQ _0x3B
_0x3A:
	RJMP _0x39
_0x3B:
	LDI  R17,LOW(29)
; 0000 00A3   if (day>qty_days) {M++; day=1; change=0;};//       
_0x39:
	CP   R17,R5
	BRSH _0x3C
	INC  R11
	LDI  R30,LOW(1)
	MOV  R5,R30
	CLT
	BLD  R2,3
_0x3C:
; 0000 00A4 
; 0000 00A5   if ((M==3) && (day==time_mart) && (change==0)) //    
	LDI  R30,LOW(3)
	CP   R30,R11
	BRNE _0x3E
	CP   R14,R5
	BRNE _0x3E
	RCALL SUBOPT_0x68
	BREQ _0x3F
_0x3E:
	RJMP _0x3D
_0x3F:
; 0000 00A6   {                                                      //   
; 0000 00A7     if (hr==1)                                           //   
	LDI  R30,LOW(1)
	CP   R30,R4
	BRNE _0x40
; 0000 00A8     {
; 0000 00A9       hr++;                                              //   
	INC  R4
; 0000 00AA       change=1;                                          //    
	SET
	BLD  R2,3
; 0000 00AB     }
; 0000 00AC   };
_0x40:
_0x3D:
; 0000 00AD 
; 0000 00AE   if ((M==10) && (day==time_octb) && (change==0)) //    
	LDI  R30,LOW(10)
	CP   R30,R11
	BRNE _0x42
	CP   R13,R5
	BRNE _0x42
	RCALL SUBOPT_0x68
	BREQ _0x43
_0x42:
	RJMP _0x41
_0x43:
; 0000 00AF   {                                                       //   
; 0000 00B0     if (hr==1)                                            //  
	LDI  R30,LOW(1)
	CP   R30,R4
	BRNE _0x44
; 0000 00B1     {
; 0000 00B2       hr--;                                               //   
	DEC  R4
; 0000 00B3       change=1;                                           //    
	SET
	BLD  R2,3
; 0000 00B4     }
; 0000 00B5   };
_0x44:
_0x41:
; 0000 00B6 
; 0000 00B7   if (M>12) {M=1; Y++;};// e  12
	LDI  R30,LOW(12)
	CP   R30,R11
	BRSH _0x45
	LDI  R30,LOW(1)
	MOV  R11,R30
	LDI  R26,LOW(_Y)
	LDI  R27,HIGH(_Y)
	RCALL __GETD1P_INC
	RCALL SUBOPT_0x69
	RCALL __PUTDP1_DEC
_0x45:
; 0000 00B8   recode_time(); //    
	RCALL _recode_time
; 0000 00B9 }
_0x2080005:
	LD   R17,Y+
	RET
;
; void on_of_led(void)
; 0000 00BC   {
_on_of_led:
; 0000 00BD     long int time_dn, time_up, time_now;//       
; 0000 00BE     time_up=(HH[0]*60 + MM[0]) - cor;// cor    
	SBIW R28,12
;	time_dn -> Y+8
;	time_up -> Y+4
;	time_now -> Y+0
	LDS  R26,_HH
	LDS  R27,_HH+1
	LDS  R24,_HH+2
	LDS  R25,_HH+3
	__GETD1N 0x3C
	RCALL __MULD12
	LDS  R26,_MM
	LDS  R27,_MM+1
	LDS  R24,_MM+2
	LDS  R25,_MM+3
	RCALL SUBOPT_0x6A
	RCALL __SUBD21
	__PUTD2S 4
; 0000 00BF     time_dn=(HH[1]*60 + MM[1]) + cor;// cor    
	__GETD1MN _HH,4
	RCALL SUBOPT_0x6B
	RCALL SUBOPT_0x6
	__GETD1MN _MM,4
	RCALL SUBOPT_0x6A
	RCALL __ADDD12
	__PUTD1S 8
; 0000 00C0     time_now=(long int)hr*60 + mins;
	RCALL SUBOPT_0x6C
	RCALL SUBOPT_0x6B
	MOVW R26,R30
	MOVW R24,R22
	RCALL SUBOPT_0x6D
	RCALL __ADDD12
	RCALL SUBOPT_0x6E
; 0000 00C1     if (st==1) {light_on;} else
	SBRC R2,2
	RJMP _0x6F
; 0000 00C2     if ((time_now>=time_up)&&(time_now<=time_dn)) {light_off;}  //   T > T   T < T  
	RCALL SUBOPT_0x34
	RCALL SUBOPT_0x6F
	RCALL __CPD21
	BRLT _0x4B
	__GETD1S 8
	RCALL SUBOPT_0x6F
	RCALL __CPD12
	BRGE _0x4C
_0x4B:
	RJMP _0x4A
_0x4C:
	CBI  0x15,5
; 0000 00C3     else {light_on;};// ,   ,   .    ,
	RJMP _0x4F
_0x4A:
_0x6F:
	SBI  0x15,5
_0x4F:
; 0000 00C4     //    
; 0000 00C5   }
	ADIW R28,12
	RET
;
;void keypress(unsigned char ind, long int ddey, int ga, int gb, char sw)
; 0000 00C8 {
_keypress:
; 0000 00C9   while (key!=Ok)
;	ind -> Y+9
;	ddey -> Y+5
;	ga -> Y+3
;	gb -> Y+1
;	sw -> Y+0
_0x52:
	LDS  R30,_Ok
	RCALL SUBOPT_0x57
	CP   R30,R26
	BRNE PC+2
	RJMP _0x54
; 0000 00CA   {
; 0000 00CB     if (sw==1)
	LD   R26,Y
	CPI  R26,LOW(0x1)
	BRNE _0x55
; 0000 00CC     {
; 0000 00CD       digit_buff[2]=digits[ddey/10%10];
	RCALL SUBOPT_0x70
	RCALL SUBOPT_0x5B
	RCALL SUBOPT_0x60
; 0000 00CE       digit_buff[3]=digits[ddey%10];
	RCALL SUBOPT_0x70
	RCALL SUBOPT_0x5D
	RCALL SUBOPT_0x61
; 0000 00CF       display();
; 0000 00D0     }
; 0000 00D1     else
_0x55:
; 0000 00D2     {
; 0000 00D3       display();
_0x70:
	RCALL _display
; 0000 00D4     }
; 0000 00D5     if ((key==Up) & (ddey<ga)) {ddey++; delay_ms(200);}
	LDS  R30,_Up
	RCALL SUBOPT_0x57
	RCALL __EQB12
	MOV  R0,R30
	LDD  R30,Y+3
	LDD  R31,Y+3+1
	RCALL SUBOPT_0x71
	RCALL __LTD12
	AND  R30,R0
	BREQ _0x57
	RCALL SUBOPT_0x72
	RCALL SUBOPT_0x69
	RCALL SUBOPT_0x73
; 0000 00D6     if ((key==Down) & (ddey>gb)) {ddey--; delay_ms(200);}
_0x57:
	LDS  R30,_Down
	RCALL SUBOPT_0x57
	RCALL __EQB12
	MOV  R0,R30
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	RCALL SUBOPT_0x71
	RCALL __GTD12
	AND  R30,R0
	BREQ _0x58
	RCALL SUBOPT_0x72
	SBIW R30,1
	SBCI R22,0
	SBCI R23,0
	RCALL SUBOPT_0x73
; 0000 00D7     if (ind==1) {}
_0x58:
; 0000 00D8     if (ind==2) {B5=ddey;}
	LDD  R26,Y+9
	CPI  R26,LOW(0x2)
	BRNE _0x5A
	LDD  R8,Y+5
; 0000 00D9     if (ind==3) {lat=(float)ddey;}
_0x5A:
	LDD  R26,Y+9
	CPI  R26,LOW(0x3)
	BRNE _0x5B
	RCALL SUBOPT_0x72
	RCALL __CDF1
	RCALL __CFD1U
	MOV  R9,R30
; 0000 00DA     if (ind==4) {M=ddey;}
_0x5B:
	LDD  R26,Y+9
	CPI  R26,LOW(0x4)
	BRNE _0x5C
	LDD  R11,Y+5
; 0000 00DB     if (ind==5) {day=ddey;}
_0x5C:
	LDD  R26,Y+9
	CPI  R26,LOW(0x5)
	BRNE _0x5D
	LDD  R5,Y+5
; 0000 00DC     if (ind==6) {Y=ddey;}
_0x5D:
	LDD  R26,Y+9
	CPI  R26,LOW(0x6)
	BRNE _0x5E
	RCALL SUBOPT_0x72
	STS  _Y,R30
	STS  _Y+1,R31
	STS  _Y+2,R22
	STS  _Y+3,R23
; 0000 00DD     if (ind==7) {hr=ddey;}
_0x5E:
	LDD  R26,Y+9
	CPI  R26,LOW(0x7)
	BRNE _0x5F
	LDD  R4,Y+5
; 0000 00DE     if (ind==8) {mins=ddey;}
_0x5F:
	LDD  R26,Y+9
	CPI  R26,LOW(0x8)
	BRNE _0x60
	LDD  R3,Y+5
; 0000 00DF     if (ind==9) {cor=ddey;}
_0x60:
	LDD  R26,Y+9
	CPI  R26,LOW(0x9)
	BRNE _0x61
	LDD  R12,Y+5
; 0000 00E0     if (ind==10) {H=ddey;}
_0x61:
	LDD  R26,Y+9
	CPI  R26,LOW(0xA)
	BRNE _0x62
	LDD  R10,Y+5
; 0000 00E1   }
_0x62:
	RJMP _0x52
_0x54:
; 0000 00E2   me_delay();
	RCALL _me_delay
; 0000 00E3 }
_0x2080004:
	ADIW R28,10
	RET
;
;void menu(void)
; 0000 00E6 {
_menu:
; 0000 00E7   digit_buff[0]=digits[25]; //A
	__POINTW1FN _digits,25
	RCALL SUBOPT_0x74
; 0000 00E8   digit_buff[1]=digits[12]; //t
	RCALL SUBOPT_0x75
; 0000 00E9   digit_buff[2]=digits[0]; //0
	LDI  R30,LOW(_digits*2)
	LDI  R31,HIGH(_digits*2)
	LPM  R0,Z
	RCALL SUBOPT_0x60
; 0000 00EA   digit_buff[3]=digits[3]; //3
	__POINTW1FN _digits,3
	LPM  R0,Z
	RCALL SUBOPT_0x61
; 0000 00EB   keypress(1,0,0,0,0);
	RCALL SUBOPT_0x51
	__GETD1N 0x0
	RCALL __PUTPARD1
	RCALL SUBOPT_0x76
	RCALL SUBOPT_0x76
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL SUBOPT_0x77
; 0000 00EC 
; 0000 00ED   digit_buff[0]=digits[10]; //L
; 0000 00EE   digit_buff[1]=digits[11]; //n
	RCALL SUBOPT_0x78
; 0000 00EF   keypress(2, B5, 90, 0, 1);
	LDI  R30,LOW(2)
	ST   -Y,R30
	MOV  R30,R8
	RCALL SUBOPT_0x79
	LDI  R30,LOW(90)
	LDI  R31,HIGH(90)
	RCALL SUBOPT_0x7A
	RCALL SUBOPT_0x51
	RCALL SUBOPT_0x77
; 0000 00F0 
; 0000 00F1   digit_buff[0]=digits[10];  //L
; 0000 00F2   digit_buff[1]=digits[12];  //t
	RCALL SUBOPT_0x75
; 0000 00F3   keypress(3, lat, 180, 0, 1);
	LDI  R30,LOW(3)
	ST   -Y,R30
	MOV  R30,R9
	RCALL SUBOPT_0x79
	LDI  R30,LOW(180)
	LDI  R31,HIGH(180)
	RCALL SUBOPT_0x7A
	RCALL SUBOPT_0x51
	RCALL _keypress
; 0000 00F4 
; 0000 00F5   digit_buff[0]=digits[15];    // 
	__POINTW1FN _digits,15
	RCALL SUBOPT_0x74
; 0000 00F6   digit_buff[1]=digits[16];    //7 
	__POINTW1FN _digits,16
	RCALL SUBOPT_0x7B
; 0000 00F7   keypress(4, M, 12, 1, 1);
	LDI  R30,LOW(4)
	ST   -Y,R30
	MOV  R30,R11
	RCALL SUBOPT_0x79
	LDI  R30,LOW(12)
	LDI  R31,HIGH(12)
	RCALL SUBOPT_0x7C
	RCALL SUBOPT_0x7D
	RCALL _keypress
; 0000 00F8 
; 0000 00F9   digit_buff[0]=digits[20];     // d
	__POINTW1FN _digits,20
	RCALL SUBOPT_0x74
; 0000 00FA  // digit_buff[0]=digits[23];     //.
; 0000 00FB   digit_buff[1]=digits[11];    // n
	RCALL SUBOPT_0x78
; 0000 00FC   keypress(5, day, days_month[M-1], 1, 1);
	LDI  R30,LOW(5)
	ST   -Y,R30
	MOV  R30,R5
	RCALL SUBOPT_0x79
	RCALL SUBOPT_0x66
	LPM  R30,Z
	LDI  R31,0
	RCALL SUBOPT_0x7C
	RCALL SUBOPT_0x7D
	RCALL SUBOPT_0x7E
; 0000 00FD 
; 0000 00FE   digit_buff[0]=digits[2];    //2
; 0000 00FF   digit_buff[1]=digits[0];    //0
	LDI  R30,LOW(_digits*2)
	LDI  R31,HIGH(_digits*2)
	RCALL SUBOPT_0x7B
; 0000 0100   keypress(6, Y, 2100, 2000, 1);
	LDI  R30,LOW(6)
	ST   -Y,R30
	RCALL SUBOPT_0x12
	RCALL __PUTPARD1
	LDI  R30,LOW(2100)
	LDI  R31,HIGH(2100)
	RCALL SUBOPT_0x7C
	LDI  R30,LOW(2000)
	LDI  R31,HIGH(2000)
	RCALL SUBOPT_0x7C
	RCALL SUBOPT_0x51
	RCALL _keypress
; 0000 0101 
; 0000 0102   digit_buff[0]=digits[21];   //h
	__POINTW1FN _digits,21
	RCALL SUBOPT_0x74
; 0000 0103   digit_buff[1]=digits[22];   //r
	__POINTW1FN _digits,22
	RCALL SUBOPT_0x7B
; 0000 0104   keypress(7, hr, 23, 0, 1);
	LDI  R30,LOW(7)
	ST   -Y,R30
	RCALL SUBOPT_0x6C
	RCALL __PUTPARD1
	LDI  R30,LOW(23)
	LDI  R31,HIGH(23)
	RCALL SUBOPT_0x7A
	RCALL SUBOPT_0x51
	RCALL _keypress
; 0000 0105 
; 0000 0106   digit_buff[0]=digits[19];   //n
	__POINTW1FN _digits,19
	RCALL SUBOPT_0x74
; 0000 0107   digit_buff[1]=digits[19];   //n
	__POINTW1FN _digits,19
	RCALL SUBOPT_0x7B
; 0000 0108   keypress(8, mins, 59, 0, 1);
	LDI  R30,LOW(8)
	ST   -Y,R30
	RCALL SUBOPT_0x6D
	RCALL __PUTPARD1
	LDI  R30,LOW(59)
	LDI  R31,HIGH(59)
	RCALL SUBOPT_0x7A
	RCALL SUBOPT_0x51
	RCALL _keypress
; 0000 0109 
; 0000 010A   digit_buff[0]=digits[13];   //C
	__POINTW1FN _digits,13
	RCALL SUBOPT_0x74
; 0000 010B   digit_buff[1]=digits[14];   //o
	__POINTW1FN _digits,14
	RCALL SUBOPT_0x7B
; 0000 010C   keypress(9, cor, 59, 0, 1);  //
	LDI  R30,LOW(9)
	ST   -Y,R30
	MOV  R30,R12
	RCALL SUBOPT_0x79
	LDI  R30,LOW(59)
	LDI  R31,HIGH(59)
	RCALL SUBOPT_0x7A
	RCALL SUBOPT_0x51
	RCALL SUBOPT_0x7E
; 0000 010D 
; 0000 010E   digit_buff[0]=digits[2];    //z
; 0000 010F   digit_buff[1]=digits[11];   //n
	RCALL SUBOPT_0x78
; 0000 0110   keypress(10, H, 12, 0, 1);
	LDI  R30,LOW(10)
	ST   -Y,R30
	MOV  R30,R10
	RCALL SUBOPT_0x79
	LDI  R30,LOW(12)
	LDI  R31,HIGH(12)
	RCALL SUBOPT_0x7A
	RCALL SUBOPT_0x51
	RCALL _keypress
; 0000 0111 
; 0000 0112   sec=0;
	CLR  R6
; 0000 0113   change=0; // 
	CLT
	BLD  R2,3
; 0000 0114   display();
_0x2080003:
	RCALL _display
; 0000 0115 }
	RET
;
;
;void main(void)
; 0000 0119 {
_main:
; 0000 011A // Declare your local variables here
; 0000 011B 
; 0000 011C // Input/Output Ports initialization
; 0000 011D // Port B initialization
; 0000 011E // Func7=In Func6=In Func5=In Func4=Out Func3=Out Func2=Out Func1=Out Func0=In
; 0000 011F // State7=T State6=T State5=T State4=0 State3=0 State2=0 State1=0 State0=T
; 0000 0120 PORTB=0x00;
	LDI  R30,LOW(0)
	OUT  0x18,R30
; 0000 0121 DDRB=0x1E;
	LDI  R30,LOW(30)
	OUT  0x17,R30
; 0000 0122 
; 0000 0123 // Port C initialization
; 0000 0124 // Func6=In Func5=Out Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 0125 // State6=T State5=0 State4=P State3=P State2=P State1=P State0=P
; 0000 0126 PORTC=0x1F;
	LDI  R30,LOW(31)
	OUT  0x15,R30
; 0000 0127 DDRC=0x20;
	LDI  R30,LOW(32)
	OUT  0x14,R30
; 0000 0128 
; 0000 0129 // Port D initialization
; 0000 012A // Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
; 0000 012B // State7=0 State6=0 State5=0 State4=0 State3=0 State2=0 State1=0 State0=0
; 0000 012C PORTD=0x00;
	LDI  R30,LOW(0)
	OUT  0x12,R30
; 0000 012D DDRD=0xFF;
	LDI  R30,LOW(255)
	OUT  0x11,R30
; 0000 012E 
; 0000 012F // Timer/Counter 0 initialization
; 0000 0130 // Clock source: System Clock
; 0000 0131 // Clock value: 15,625 kHz
; 0000 0132 TCCR0=0x04;
	LDI  R30,LOW(4)
	OUT  0x33,R30
; 0000 0133 TCNT0=0x00;
	LDI  R30,LOW(0)
	OUT  0x32,R30
; 0000 0134 
; 0000 0135 // Timer/Counter 1 initialization
; 0000 0136 // Clock source: System Clock
; 0000 0137 // Clock value: Timer 1 Stopped
; 0000 0138 // Mode: Normal top=FFFFh
; 0000 0139 // OC1A output: Discon.
; 0000 013A // OC1B output: Discon.
; 0000 013B // Noise Canceler: Off
; 0000 013C // Input Capture on Falling Edge
; 0000 013D // Timer 1 Overflow Interrupt: Off
; 0000 013E // Input Capture Interrupt: Off
; 0000 013F // Compare A Match Interrupt: Off
; 0000 0140 // Compare B Match Interrupt: Off
; 0000 0141 TCCR1A=0x00;
	OUT  0x2F,R30
; 0000 0142 TCCR1B=0x00;
	OUT  0x2E,R30
; 0000 0143 TCNT1H=0x00;
	OUT  0x2D,R30
; 0000 0144 TCNT1L=0x00;
	OUT  0x2C,R30
; 0000 0145 ICR1H=0x00;
	OUT  0x27,R30
; 0000 0146 ICR1L=0x00;
	OUT  0x26,R30
; 0000 0147 OCR1AH=0x1E;
	LDI  R30,LOW(30)
	OUT  0x2B,R30
; 0000 0148 OCR1AL=0x85;
	LDI  R30,LOW(133)
	OUT  0x2A,R30
; 0000 0149 OCR1BH=0x00;
	LDI  R30,LOW(0)
	OUT  0x29,R30
; 0000 014A OCR1BL=0x00;
	OUT  0x28,R30
; 0000 014B 
; 0000 014C // Timer/Counter 2 initialization
; 0000 014D // Clock source: TOSC1 pin
; 0000 014E // Clock value: PCK2/128
; 0000 014F // Mode: Normal top=FFh
; 0000 0150 // OC2 output: Disconnected
; 0000 0151 ASSR=0x08;
	LDI  R30,LOW(8)
	OUT  0x22,R30
; 0000 0152 TCCR2=0x05;
	LDI  R30,LOW(5)
	OUT  0x25,R30
; 0000 0153 TCNT2=0x00;
	LDI  R30,LOW(0)
	OUT  0x24,R30
; 0000 0154 OCR2=0x00;
	OUT  0x23,R30
; 0000 0155 
; 0000 0156 // External Interrupt(s) initialization
; 0000 0157 // INT0: Off
; 0000 0158 // INT1: Off
; 0000 0159 MCUCR=0x00;
	OUT  0x35,R30
; 0000 015A 
; 0000 015B // Timer(s)/Counter(s) Interrupt(s) initialization
; 0000 015C TIMSK=0x41;
	LDI  R30,LOW(65)
	OUT  0x39,R30
; 0000 015D 
; 0000 015E // Analog Comparator initialization
; 0000 015F // Analog Comparator: Off
; 0000 0160 // Analog Comparator Input Capture by Timer/Counter 1: Off
; 0000 0161 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
; 0000 0162 SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
; 0000 0163 
; 0000 0164 // Global enable interrupts
; 0000 0165 #asm("sei")
	sei
; 0000 0166 
; 0000 0167 
; 0000 0168 //while (key!=Ok){lcd_gotoxy(0,0); lcd_putsf(info);}
; 0000 0169 me_delay();
	RCALL _me_delay
; 0000 016A 
; 0000 016B menu();
	RCALL _menu
; 0000 016C show_info();
	RCALL _show_info
; 0000 016D recode_time();
	RCALL _recode_time
; 0000 016E display();
	RCALL _display
; 0000 016F 
; 0000 0170 while (1)
_0x63:
; 0000 0171       {
; 0000 0172       // Place your code here
; 0000 0173           if (key !=31) {me_delay(); menu(); show_info();};
	RCALL SUBOPT_0x57
	CPI  R26,LOW(0x1F)
	BREQ _0x66
	RCALL _me_delay
	RCALL _menu
	RCALL _show_info
_0x66:
; 0000 0174           clock();
	RCALL _clock
; 0000 0175           recode_time();
	RCALL _recode_time
; 0000 0176           display();
	RCALL _display
; 0000 0177           on_of_led();
	RCALL _on_of_led
; 0000 0178           while (key==Up) {sun_up();};
_0x67:
	LDS  R30,_Up
	RCALL SUBOPT_0x57
	CP   R30,R26
	BRNE _0x69
	RCALL _sun_up
	RJMP _0x67
_0x69:
; 0000 0179           while (key==Down) {sun_dn();};
_0x6A:
	LDS  R30,_Down
	RCALL SUBOPT_0x57
	CP   R30,R26
	BRNE _0x6C
	RCALL _sun_dn
	RJMP _0x6A
_0x6C:
; 0000 017A       };
	RJMP _0x63
; 0000 017B }
_0x6D:
	RJMP _0x6D

	.CSEG
_ftrunc:
   ldd  r23,y+3
   ldd  r22,y+2
   ldd  r31,y+1
   ld   r30,y
   bst  r23,7
   lsl  r23
   sbrc r22,7
   sbr  r23,1
   mov  r25,r23
   subi r25,0x7e
   breq __ftrunc0
   brcs __ftrunc0
   cpi  r25,24
   brsh __ftrunc1
   clr  r26
   clr  r27
   clr  r24
__ftrunc2:
   sec
   ror  r24
   ror  r27
   ror  r26
   dec  r25
   brne __ftrunc2
   and  r30,r26
   and  r31,r27
   and  r22,r24
   rjmp __ftrunc1
__ftrunc0:
   clt
   clr  r23
   clr  r30
   clr  r31
   clr  r22
__ftrunc1:
   cbr  r22,0x80
   lsr  r23
   brcc __ftrunc3
   sbr  r22,0x80
__ftrunc3:
   bld  r23,7
   ld   r26,y+
   ld   r27,y+
   ld   r24,y+
   ld   r25,y+
   cp   r30,r26
   cpc  r31,r27
   cpc  r22,r24
   cpc  r23,r25
   bst  r25,7
   ret
_floor:
	RCALL SUBOPT_0x2
	RCALL _ftrunc
	RCALL SUBOPT_0x6E
    brne __floor1
__floor0:
	RCALL SUBOPT_0x1
	RJMP _0x2080001
__floor1:
    brtc __floor0
	RCALL SUBOPT_0x6F
	RCALL SUBOPT_0x14
	RCALL SUBOPT_0x8
	RJMP _0x2080001
_ceil:
	RCALL SUBOPT_0x2
	RCALL _ftrunc
	RCALL SUBOPT_0x6E
    brne __ceil1
__ceil0:
	RCALL SUBOPT_0x1
	RJMP _0x2080001
__ceil1:
    brts __ceil0
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x13
	RCALL __ADDF12
	RJMP _0x2080001
_sin:
	SBIW R28,4
	ST   -Y,R17
	LDI  R17,0
	RCALL SUBOPT_0x7F
	__GETD1N 0x3E22F983
	RCALL __MULF12
	RCALL SUBOPT_0x80
	RCALL SUBOPT_0x72
	RCALL __PUTPARD1
	RCALL _floor
	RCALL SUBOPT_0x7F
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0x80
	RCALL SUBOPT_0x7F
	RCALL SUBOPT_0x7
	RCALL __CMPF12
	BREQ PC+2
	BRCC PC+2
	RJMP _0x2000017
	RCALL SUBOPT_0x7F
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0x80
	LDI  R17,LOW(1)
_0x2000017:
	RCALL SUBOPT_0x7F
	__GETD1N 0x3E800000
	RCALL __CMPF12
	BREQ PC+2
	BRCC PC+2
	RJMP _0x2000018
	RCALL SUBOPT_0x7F
	RCALL SUBOPT_0x7
	RCALL __SUBF12
	RCALL SUBOPT_0x80
_0x2000018:
	CPI  R17,0
	BREQ _0x2000019
	RCALL SUBOPT_0x72
	RCALL __ANEGF1
	RCALL SUBOPT_0x80
_0x2000019:
	RCALL SUBOPT_0x72
	RCALL SUBOPT_0x7F
	RCALL __MULF12
	__PUTD1S 1
	RCALL SUBOPT_0x81
	__GETD2N 0x4226C4B1
	RCALL __MULF12
	RCALL SUBOPT_0x6
	__GETD1N 0x422DE51D
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0x82
	__GETD2N 0x4104534C
	RCALL __ADDF12
	RCALL SUBOPT_0x7F
	RCALL __MULF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x81
	__GETD2N 0x3FDEED11
	RCALL __ADDF12
	RCALL SUBOPT_0x82
	__GETD2N 0x3FA87B5E
	RCALL __ADDF12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	RCALL __DIVF21
	LDD  R17,Y+0
	ADIW R28,9
	RET
_cos:
	RCALL SUBOPT_0x6F
	__GETD1N 0x3FC90FDB
	RCALL __SUBF12
	RCALL SUBOPT_0x29
	RJMP _0x2080001
_xatan:
	SBIW R28,4
	RCALL SUBOPT_0x34
	RCALL SUBOPT_0x83
	RCALL SUBOPT_0x6E
	RCALL SUBOPT_0x1
	__GETD2N 0x40CBD065
	RCALL SUBOPT_0x84
	RCALL SUBOPT_0x83
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x1
	__GETD2N 0x41296D00
	RCALL __ADDF12
	RCALL SUBOPT_0x6F
	RCALL SUBOPT_0x84
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	RCALL __DIVF21
_0x2080002:
	ADIW R28,8
	RET
_yatan:
	RCALL SUBOPT_0x6F
	__GETD1N 0x3ED413CD
	RCALL __CMPF12
	BRSH _0x2000020
	RCALL SUBOPT_0x2
	RCALL _xatan
	RJMP _0x2080001
_0x2000020:
	RCALL SUBOPT_0x6F
	__GETD1N 0x401A827A
	RCALL __CMPF12
	BREQ PC+2
	BRCC PC+2
	RJMP _0x2000021
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x1F
	RCALL _xatan
	__GETD2N 0x3FC90FDB
	RCALL SUBOPT_0x8
	RJMP _0x2080001
_0x2000021:
	RCALL SUBOPT_0x6F
	RCALL SUBOPT_0x14
	RCALL SUBOPT_0x8
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x13
	RCALL __ADDF12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	RCALL SUBOPT_0x1F
	RCALL _xatan
	__GETD2N 0x3F490FDB
	RCALL __ADDF12
	RJMP _0x2080001
_atan:
	RCALL SUBOPT_0x0
	BRMI _0x200002C
	RCALL SUBOPT_0x2
	RCALL _yatan
	RJMP _0x2080001
_0x200002C:
	RCALL SUBOPT_0x1
	RCALL __ANEGF1
	RCALL __PUTPARD1
	RCALL _yatan
	RCALL __ANEGF1
_0x2080001:
	ADIW R28,4
	RET

	.CSEG

	.DSEG

	.CSEG

	.CSEG

	.CSEG

	.DSEG
_J3:
	.BYTE 0x4
_Y:
	.BYTE 0x4
_MM:
	.BYTE 0x8
_HH:
	.BYTE 0x8
_aA:
	.BYTE 0x8
_aD:
	.BYTE 0x8
_D:
	.BYTE 0x4
_T:
	.BYTE 0x4
_T0:
	.BYTE 0x4
_TT:
	.BYTE 0x4
_A:
	.BYTE 0x4
_B:
	.BYTE 0x4
_A0:
	.BYTE 0x4
_D0:
	.BYTE 0x4
_D1:
	.BYTE 0x4
_E:
	.BYTE 0x4
_F:
	.BYTE 0x4
_J:
	.BYTE 0x4
_S:
	.BYTE 0x4
_L:
	.BYTE 0x4
_G:
	.BYTE 0x4
_V:
	.BYTE 0x4
_U:
	.BYTE 0x4
_V0:
	.BYTE 0x4
_V1:
	.BYTE 0x4
_V2:
	.BYTE 0x4
_Ok:
	.BYTE 0x1
_Down:
	.BYTE 0x1
_Up:
	.BYTE 0x1
_key:
	.BYTE 0x1
_digit_buff:
	.BYTE 0x4
__seed_G101:
	.BYTE 0x4
_p_S1030024:
	.BYTE 0x2

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x0:
	LDD  R26,Y+3
	TST  R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 18 TIMES, CODE SIZE REDUCTION:49 WORDS
SUBOPT_0x1:
	__GETD1S 0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x2:
	RCALL SUBOPT_0x1
	RCALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x3:
	LDS  R30,_D
	LDS  R31,_D+1
	LDS  R22,_D+2
	LDS  R23,_D+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 15 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x4:
	RCALL __PUTPARD1
	RJMP _Trunc

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x5:
	LDS  R26,_D1
	LDS  R27,_D1+1
	LDS  R24,_D1+2
	LDS  R25,_D1+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 17 TIMES, CODE SIZE REDUCTION:14 WORDS
SUBOPT_0x6:
	MOVW R26,R30
	MOVW R24,R22
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x7:
	__GETD1N 0x3F000000
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 28 TIMES, CODE SIZE REDUCTION:25 WORDS
SUBOPT_0x8:
	RCALL __SWAPD12
	RCALL __SUBF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x9:
	STS  _F,R30
	STS  _F+1,R31
	STS  _F+2,R22
	STS  _F+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xA:
	MOV  R30,R11
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __CDF1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xB:
	RCALL __ADDF12
	RJMP SUBOPT_0x6

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:26 WORDS
SUBOPT_0xC:
	LDS  R26,_Y
	LDS  R27,_Y+1
	LDS  R24,_Y+2
	LDS  R25,_Y+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0xD:
	RCALL __PUTDP1
	MOV  R30,R11
	SUBI R30,LOW(9)
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __CDF1
	RCALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xE:
	RCALL __CWD1
	RCALL __CDF1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 13 TIMES, CODE SIZE REDUCTION:82 WORDS
SUBOPT_0xF:
	LDS  R26,_S
	LDS  R27,_S+1
	LDS  R24,_S+2
	LDS  R25,_S+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x10:
	LDS  R26,_J
	LDS  R27,_J+1
	LDS  R24,_J+2
	LDS  R25,_J+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x11:
	RCALL __CDF1
	RCALL __ADDF12
	STS  _J,R30
	STS  _J+1,R31
	STS  _J+2,R22
	STS  _J+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x12:
	LDS  R30,_Y
	LDS  R31,_Y+1
	LDS  R22,_Y+2
	LDS  R23,_Y+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:25 WORDS
SUBOPT_0x13:
	__GETD2N 0x3F800000
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x14:
	__GETD1N 0x3F800000
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:19 WORDS
SUBOPT_0x15:
	LDS  R30,_T
	LDS  R31,_T+1
	LDS  R22,_T+2
	LDS  R23,_T+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:22 WORDS
SUBOPT_0x16:
	RCALL __ADDF12
	STS  _S,R30
	STS  _S+1,R31
	STS  _S+2,R22
	STS  _S+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x17:
	MOV  R30,R10
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __CDF1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x18:
	RCALL __MULF12
	RJMP SUBOPT_0xF

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x19:
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __CDF1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:14 WORDS
SUBOPT_0x1A:
	RCALL __DIVF21
	STS  _S,R30
	STS  _S+1,R31
	STS  _S+2,R22
	STS  _S+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x1B:
	LDS  R30,_S
	LDS  R31,_S+1
	LDS  R22,_S+2
	LDS  R23,_S+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1C:
	RCALL __CDF1
	RJMP SUBOPT_0x8

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:26 WORDS
SUBOPT_0x1D:
	STS  _S,R30
	STS  _S+1,R31
	STS  _S+2,R22
	STS  _S+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x1E:
	LDI  R30,LOW(_DR*2)
	LDI  R31,HIGH(_DR*2)
	RCALL __GETD1PF
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x1F:
	RCALL __DIVF21
	RCALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x20:
	RCALL __ADDF12
	STS  _L,R30
	STS  _L+1,R31
	STS  _L+2,R22
	STS  _L+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x21:
	RCALL __ADDF12
	STS  _G,R30
	STS  _G+1,R31
	STS  _G+2,R22
	STS  _G+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:61 WORDS
SUBOPT_0x22:
	LDS  R30,_L
	LDS  R31,_L+1
	LDS  R22,_L+2
	LDS  R23,_L+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:26 WORDS
SUBOPT_0x23:
	LDS  R26,_L
	LDS  R27,_L+1
	LDS  R24,_L+2
	LDS  R25,_L+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x24:
	STS  _L,R30
	STS  _L+1,R31
	STS  _L+2,R22
	STS  _L+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:40 WORDS
SUBOPT_0x25:
	LDS  R30,_G
	LDS  R31,_G+1
	LDS  R22,_G+2
	LDS  R23,_G+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:33 WORDS
SUBOPT_0x26:
	LDS  R26,_G
	LDS  R27,_G+1
	LDS  R24,_G+2
	LDS  R25,_G+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x27:
	STS  _G,R30
	STS  _G+1,R31
	STS  _G+2,R22
	STS  _G+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x28:
	LDI  R30,LOW(_P2*2)
	LDI  R31,HIGH(_P2*2)
	RCALL __GETD1PF
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 12 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x29:
	RCALL __PUTPARD1
	RJMP _sin

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:19 WORDS
SUBOPT_0x2A:
	STS  _V,R30
	STS  _V+1,R31
	STS  _V+2,R22
	STS  _V+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:14 WORDS
SUBOPT_0x2B:
	RCALL __MULF12
	LDS  R26,_V
	LDS  R27,_V+1
	LDS  R24,_V+2
	LDS  R25,_V+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x2C:
	LDS  R30,_TT
	LDS  R31,_TT+1
	LDS  R22,_TT+2
	LDS  R23,_TT+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x2D:
	RCALL __PUTPARD1
	RJMP _cos

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:14 WORDS
SUBOPT_0x2E:
	STS  _U,R30
	STS  _U+1,R31
	STS  _U+2,R22
	STS  _U+3,R23
	RJMP SUBOPT_0x22

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:26 WORDS
SUBOPT_0x2F:
	__GETD2N 0x40000000
	RCALL __MULF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:14 WORDS
SUBOPT_0x30:
	RCALL __MULF12
	LDS  R26,_U
	LDS  R27,_U+1
	LDS  R24,_U+2
	LDS  R25,_U+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x31:
	__GETD2N 0x38A7C5AC
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x32:
	LDS  R26,_V
	LDS  R27,_V+1
	LDS  R24,_V+2
	LDS  R25,_V+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x33:
	LDI  R31,0
	RCALL __LSLW2
	ADD  R30,R26
	ADC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x34:
	__GETD1S 4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x35:
	MOV  R26,R8
	CLR  R27
	CLR  R24
	CLR  R25
	RCALL __CDF2
	RCALL __MULF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x36:
	LD   R30,Y
	LDD  R31,Y+1
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x13
	RJMP SUBOPT_0xB

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x37:
	__GETD1N 0x41C00000
	RCALL __DIVF21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x38:
	LDS  R26,_aA
	LDS  R27,_aA+1
	LDS  R24,_aA+2
	LDS  R25,_aA+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x39:
	LDS  R26,_aD
	LDS  R27,_aD+1
	LDS  R24,_aD+2
	LDS  R25,_aD+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:14 WORDS
SUBOPT_0x3A:
	LDI  R30,LOW(_K1*2)
	LDI  R31,HIGH(_K1*2)
	RCALL __GETD1PF
	LD   R26,Y
	LDD  R27,Y+1
	RCALL __CWD2
	RCALL __CDF2
	RCALL __MULF12
	LDS  R26,_T0
	LDS  R27,_T0+1
	LDS  R24,_T0+2
	LDS  R25,_T0+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x3B:
	STS  _A,R30
	STS  _A+1,R31
	STS  _A+2,R22
	STS  _A+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x3C:
	RCALL __SUBF12
	STS  _B,R30
	STS  _B+1,R31
	STS  _B+2,R22
	STS  _B+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x3D:
	LDS  R30,_D0
	LDS  R31,_D0+1
	LDS  R22,_D0+2
	LDS  R23,_D0+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:47 WORDS
SUBOPT_0x3E:
	LDS  R30,_A
	LDS  R31,_A+1
	LDS  R22,_A+2
	LDS  R23,_A+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x3F:
	STS  _V0,R30
	STS  _V0+1,R31
	STS  _V0+2,R22
	STS  _V0+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:33 WORDS
SUBOPT_0x40:
	LDS  R30,_B
	LDS  R31,_B+1
	LDS  R22,_B+2
	LDS  R23,_B+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x41:
	LDS  R30,_V0
	LDS  R31,_V0+1
	LDS  R22,_V0+2
	LDS  R23,_V0+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x42:
	LDS  R30,_V2
	LDS  R31,_V2+1
	LDS  R22,_V2+2
	LDS  R23,_V2+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x43:
	__GETD1N 0x40000000
	RJMP SUBOPT_0x1F

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x44:
	LDS  R26,_B
	LDS  R27,_B+1
	LDS  R24,_B+2
	LDS  R25,_B+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x45:
	LDS  R30,_V1
	LDS  R31,_V1+1
	LDS  R22,_V1+2
	LDS  R23,_V1+3
	__GETD2N 0x40800000
	RCALL __MULF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x46:
	LDS  R26,_V2
	LDS  R27,_V2+1
	LDS  R24,_V2+2
	LDS  R25,_V2+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x47:
	LDS  R26,_V0
	LDS  R27,_V0+1
	LDS  R24,_V0+2
	LDS  R25,_V0+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x48:
	STS  _D,R30
	STS  _D+1,R31
	STS  _D+2,R22
	STS  _D+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x49:
	RCALL SUBOPT_0x40
	RCALL __ANEGF1
	LDS  R26,_D
	LDS  R27,_D+1
	LDS  R24,_D+2
	LDS  R25,_D+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x4A:
	RCALL __DIVF21
	STS  _E,R30
	STS  _E+1,R31
	STS  _E+2,R22
	STS  _E+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x4B:
	SET
	BLD  R2,2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x4C:
	STS  _A0,R30
	STS  _A0+1,R31
	STS  _A0+2,R22
	STS  _A0+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x4D:
	STS  _D0,R30
	STS  _D0+1,R31
	STS  _D0+2,R22
	STS  _D0+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x4E:
	MOVW R26,R30
	LDI  R30,LOW(12)
	LDI  R31,HIGH(12)
	RCALL __DIVW21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x4F:
	RCALL __ADDF12
	STS  _T,R30
	STS  _T+1,R31
	STS  _T+2,R22
	STS  _T+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x50:
	LDS  R26,_T
	LDS  R27,_T+1
	LDS  R24,_T+2
	LDS  R25,_T+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x51:
	LDI  R30,LOW(1)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x52:
	__GETD2MN _aA,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x53:
	LDS  R30,_aA
	LDS  R31,_aA+1
	LDS  R22,_aA+2
	LDS  R23,_aA+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x54:
	MOV  R30,R7
	LDI  R31,0
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x55:
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Get_Day
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x56:
	IN   R30,0x13
	ANDI R30,LOW(0x1F)
	STS  _key,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x57:
	LDS  R26,_key
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x58:
	ST   -Y,R31
	ST   -Y,R30
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x59:
	OUT  0x12,R30
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	RJMP SUBOPT_0x58

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x5A:
	LDS  R26,_HH
	LDS  R27,_HH+1
	LDS  R24,_HH+2
	LDS  R25,_HH+3
	__GETD1N 0xA
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:34 WORDS
SUBOPT_0x5B:
	RCALL __DIVD21
	RCALL SUBOPT_0x6
	__GETD1N 0xA
	RCALL __MODD21
	SUBI R30,LOW(-_digits*2)
	SBCI R31,HIGH(-_digits*2)
	LPM  R0,Z
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 13 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x5C:
	STS  _digit_buff,R0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x5D:
	RCALL __MODD21
	SUBI R30,LOW(-_digits*2)
	SBCI R31,HIGH(-_digits*2)
	LPM  R0,Z
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 13 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x5E:
	__PUTBR0MN _digit_buff,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x5F:
	LDS  R26,_MM
	LDS  R27,_MM+1
	LDS  R24,_MM+2
	LDS  R25,_MM+3
	__GETD1N 0xA
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x60:
	__PUTBR0MN _digit_buff,2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x61:
	__PUTBR0MN _digit_buff,3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x62:
	__GETD2MN _HH,4
	__GETD1N 0xA
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x63:
	__GETD2MN _MM,4
	__GETD1N 0xA
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x64:
	LDI  R30,LOW(10)
	RCALL __DIVB21U
	MOV  R26,R30
	LDI  R30,LOW(10)
	RCALL __MODB21U
	LDI  R31,0
	SUBI R30,LOW(-_digits*2)
	SBCI R31,HIGH(-_digits*2)
	LPM  R0,Z
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x65:
	LDI  R30,LOW(10)
	RCALL __MODB21U
	LDI  R31,0
	SUBI R30,LOW(-_digits*2)
	SBCI R31,HIGH(-_digits*2)
	LPM  R0,Z
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x66:
	MOV  R30,R11
	SUBI R30,LOW(1)
	LDI  R31,0
	SUBI R30,LOW(-_days_month*2)
	SBCI R31,HIGH(-_days_month*2)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x67:
	RCALL SUBOPT_0xC
	__GETD1N 0x4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x68:
	LDI  R26,0
	SBRC R2,3
	LDI  R26,1
	CPI  R26,LOW(0x0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x69:
	__SUBD1N -1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x6A:
	RCALL __ADDD21
	MOV  R30,R12
	CLR  R31
	CLR  R22
	CLR  R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x6B:
	__GETD2N 0x3C
	RCALL __MULD12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x6C:
	MOV  R30,R4
	CLR  R31
	CLR  R22
	CLR  R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x6D:
	MOV  R30,R3
	CLR  R31
	CLR  R22
	CLR  R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x6E:
	__PUTD1S 0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:19 WORDS
SUBOPT_0x6F:
	__GETD2S 0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x70:
	__GETD2S 5
	__GETD1N 0xA
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x71:
	__GETD2S 5
	RCALL __CWD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:16 WORDS
SUBOPT_0x72:
	__GETD1S 5
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x73:
	__PUTD1S 5
	LDI  R30,LOW(200)
	LDI  R31,HIGH(200)
	RJMP SUBOPT_0x58

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x74:
	LPM  R0,Z
	RJMP SUBOPT_0x5C

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x75:
	__POINTW1FN _digits,12
	LPM  R0,Z
	RJMP SUBOPT_0x5E

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:19 WORDS
SUBOPT_0x76:
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x77:
	RCALL _keypress
	__POINTW1FN _digits,10
	RJMP SUBOPT_0x74

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x78:
	__POINTW1FN _digits,11
	LPM  R0,Z
	RJMP SUBOPT_0x5E

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x79:
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x7A:
	ST   -Y,R31
	ST   -Y,R30
	RJMP SUBOPT_0x76

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x7B:
	LPM  R0,Z
	RJMP SUBOPT_0x5E

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x7C:
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x7D:
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RCALL SUBOPT_0x7C
	RJMP SUBOPT_0x51

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x7E:
	RCALL _keypress
	__POINTW1FN _digits,2
	RJMP SUBOPT_0x74

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:19 WORDS
SUBOPT_0x7F:
	__GETD2S 5
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x80:
	__PUTD1S 5
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x81:
	__GETD1S 1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x82:
	__GETD2S 1
	RCALL __MULF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x83:
	__GETD2S 4
	RCALL __MULF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x84:
	RCALL __MULF12
	__GETD2N 0x414A8F4E
	RCALL __ADDF12
	RET


	.CSEG
_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x3E8
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

_sqrt:
	sbiw r28,4
	push r21
	ldd  r25,y+7
	tst  r25
	brne __sqrt0
	adiw r28,8
	rjmp __zerores
__sqrt0:
	brpl __sqrt1
	adiw r28,8
	rjmp __maxres
__sqrt1:
	push r20
	ldi  r20,66
	ldd  r24,y+6
	ldd  r27,y+5
	ldd  r26,y+4
__sqrt2:
	st   y,r24
	std  y+1,r25
	std  y+2,r26
	std  y+3,r27
	movw r30,r26
	movw r22,r24
	ldd  r26,y+4
	ldd  r27,y+5
	ldd  r24,y+6
	ldd  r25,y+7
	rcall __divf21
	ld   r24,y
	ldd  r25,y+1
	ldd  r26,y+2
	ldd  r27,y+3
	rcall __addf12
	rcall __unpack1
	dec  r23
	rcall __repack
	ld   r24,y
	ldd  r25,y+1
	ldd  r26,y+2
	ldd  r27,y+3
	eor  r26,r30
	andi r26,0xf8
	brne __sqrt4
	cp   r27,r31
	cpc  r24,r22
	cpc  r25,r23
	breq __sqrt3
__sqrt4:
	dec  r20
	breq __sqrt3
	movw r26,r30
	movw r24,r22
	rjmp __sqrt2
__sqrt3:
	pop  r20
	pop  r21
	adiw r28,8
	ret

__ADDD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	ADC  R23,R25
	RET

__ADDD21:
	ADD  R26,R30
	ADC  R27,R31
	ADC  R24,R22
	ADC  R25,R23
	RET

__SUBD12:
	SUB  R30,R26
	SBC  R31,R27
	SBC  R22,R24
	SBC  R23,R25
	RET

__SUBD21:
	SUB  R26,R30
	SBC  R27,R31
	SBC  R24,R22
	SBC  R25,R23
	RET

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__ANEGD1:
	COM  R31
	COM  R22
	COM  R23
	NEG  R30
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__LSLW2:
	LSL  R30
	ROL  R31
	LSL  R30
	ROL  R31
	RET

__CBD1:
	MOV  R31,R30
	ADD  R31,R31
	SBC  R31,R31
	MOV  R22,R31
	MOV  R23,R31
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__CBD2:
	MOV  R27,R26
	ADD  R27,R27
	SBC  R27,R27
	MOV  R24,R27
	MOV  R25,R27
	RET

__CWD2:
	MOV  R24,R27
	ADD  R24,R24
	SBC  R24,R24
	MOV  R25,R24
	RET

__EQB12:
	CP   R30,R26
	LDI  R30,1
	BREQ __EQB12T
	CLR  R30
__EQB12T:
	RET

__LTD12:
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	CPC  R25,R23
	LDI  R30,1
	BRLT __LTD12T
	CLR  R30
__LTD12T:
	RET

__GTD12:
	CP   R30,R26
	CPC  R31,R27
	CPC  R22,R24
	CPC  R23,R25
	LDI  R30,1
	BRLT __GTD12T
	CLR  R30
__GTD12T:
	RET

__MULW12U:
	MUL  R31,R26
	MOV  R31,R0
	MUL  R30,R27
	ADD  R31,R0
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	RET

__MULD12U:
	MUL  R23,R26
	MOV  R23,R0
	MUL  R22,R27
	ADD  R23,R0
	MUL  R31,R24
	ADD  R23,R0
	MUL  R30,R25
	ADD  R23,R0
	MUL  R22,R26
	MOV  R22,R0
	ADD  R23,R1
	MUL  R31,R27
	ADD  R22,R0
	ADC  R23,R1
	MUL  R30,R24
	ADD  R22,R0
	ADC  R23,R1
	CLR  R24
	MUL  R31,R26
	MOV  R31,R0
	ADD  R22,R1
	ADC  R23,R24
	MUL  R30,R27
	ADD  R31,R0
	ADC  R22,R1
	ADC  R23,R24
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	ADC  R22,R24
	ADC  R23,R24
	RET

__MULW12:
	RCALL __CHKSIGNW
	RCALL __MULW12U
	BRTC __MULW121
	RCALL __ANEGW1
__MULW121:
	RET

__MULD12:
	RCALL __CHKSIGND
	RCALL __MULD12U
	BRTC __MULD121
	RCALL __ANEGD1
__MULD121:
	RET

__DIVB21U:
	CLR  R0
	LDI  R25,8
__DIVB21U1:
	LSL  R26
	ROL  R0
	SUB  R0,R30
	BRCC __DIVB21U2
	ADD  R0,R30
	RJMP __DIVB21U3
__DIVB21U2:
	SBR  R26,1
__DIVB21U3:
	DEC  R25
	BRNE __DIVB21U1
	MOV  R30,R26
	MOV  R26,R0
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__DIVW21:
	RCALL __CHKSIGNW
	RCALL __DIVW21U
	BRTC __DIVW211
	RCALL __ANEGW1
__DIVW211:
	RET

__DIVD21U:
	PUSH R19
	PUSH R20
	PUSH R21
	CLR  R0
	CLR  R1
	CLR  R20
	CLR  R21
	LDI  R19,32
__DIVD21U1:
	LSL  R26
	ROL  R27
	ROL  R24
	ROL  R25
	ROL  R0
	ROL  R1
	ROL  R20
	ROL  R21
	SUB  R0,R30
	SBC  R1,R31
	SBC  R20,R22
	SBC  R21,R23
	BRCC __DIVD21U2
	ADD  R0,R30
	ADC  R1,R31
	ADC  R20,R22
	ADC  R21,R23
	RJMP __DIVD21U3
__DIVD21U2:
	SBR  R26,1
__DIVD21U3:
	DEC  R19
	BRNE __DIVD21U1
	MOVW R30,R26
	MOVW R22,R24
	MOVW R26,R0
	MOVW R24,R20
	POP  R21
	POP  R20
	POP  R19
	RET

__DIVD21:
	RCALL __CHKSIGND
	RCALL __DIVD21U
	BRTC __DIVD211
	RCALL __ANEGD1
__DIVD211:
	RET

__MODB21U:
	RCALL __DIVB21U
	MOV  R30,R26
	RET

__MODW21:
	CLT
	SBRS R27,7
	RJMP __MODW211
	COM  R26
	COM  R27
	ADIW R26,1
	SET
__MODW211:
	SBRC R31,7
	RCALL __ANEGW1
	RCALL __DIVW21U
	MOVW R30,R26
	BRTC __MODW212
	RCALL __ANEGW1
__MODW212:
	RET

__MODD21:
	CLT
	SBRS R25,7
	RJMP __MODD211
	COM  R26
	COM  R27
	COM  R24
	COM  R25
	SUBI R26,-1
	SBCI R27,-1
	SBCI R24,-1
	SBCI R25,-1
	SET
__MODD211:
	SBRC R23,7
	RCALL __ANEGD1
	RCALL __DIVD21U
	MOVW R30,R26
	MOVW R22,R24
	BRTC __MODD212
	RCALL __ANEGD1
__MODD212:
	RET

__CHKSIGNW:
	CLT
	SBRS R31,7
	RJMP __CHKSW1
	RCALL __ANEGW1
	SET
__CHKSW1:
	SBRS R27,7
	RJMP __CHKSW2
	COM  R26
	COM  R27
	ADIW R26,1
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSW2:
	RET

__CHKSIGND:
	CLT
	SBRS R23,7
	RJMP __CHKSD1
	RCALL __ANEGD1
	SET
__CHKSD1:
	SBRS R25,7
	RJMP __CHKSD2
	CLR  R0
	COM  R26
	COM  R27
	COM  R24
	COM  R25
	ADIW R26,1
	ADC  R24,R0
	ADC  R25,R0
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSD2:
	RET

__GETD1P_INC:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X+
	RET

__PUTDP1:
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	RET

__PUTDP1_DEC:
	ST   -X,R23
	ST   -X,R22
	ST   -X,R31
	ST   -X,R30
	RET

__GETD1PF:
	LPM  R0,Z+
	LPM  R1,Z+
	LPM  R22,Z+
	LPM  R23,Z
	MOVW R30,R0
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__CDF2U:
	SET
	RJMP __CDF2U0
__CDF2:
	CLT
__CDF2U0:
	RCALL __SWAPD12
	RCALL __CDF1U0

__SWAPD12:
	MOV  R1,R24
	MOV  R24,R22
	MOV  R22,R1
	MOV  R1,R25
	MOV  R25,R23
	MOV  R23,R1

__SWAPW12:
	MOV  R1,R27
	MOV  R27,R31
	MOV  R31,R1

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__ANEGF1:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __ANEGF10
	SUBI R23,0x80
__ANEGF10:
	RET

__ROUND_REPACK:
	TST  R21
	BRPL __REPACK
	CPI  R21,0x80
	BRNE __ROUND_REPACK0
	SBRS R30,0
	RJMP __REPACK
__ROUND_REPACK0:
	ADIW R30,1
	ADC  R22,R25
	ADC  R23,R25
	BRVS __REPACK1

__REPACK:
	LDI  R21,0x80
	EOR  R21,R23
	BRNE __REPACK0
	PUSH R21
	RJMP __ZERORES
__REPACK0:
	CPI  R21,0xFF
	BREQ __REPACK1
	LSL  R22
	LSL  R0
	ROR  R21
	ROR  R22
	MOV  R23,R21
	RET
__REPACK1:
	PUSH R21
	TST  R0
	BRMI __REPACK2
	RJMP __MAXRES
__REPACK2:
	RJMP __MINRES

__UNPACK:
	LDI  R21,0x80
	MOV  R1,R25
	AND  R1,R21
	LSL  R24
	ROL  R25
	EOR  R25,R21
	LSL  R21
	ROR  R24

__UNPACK1:
	LDI  R21,0x80
	MOV  R0,R23
	AND  R0,R21
	LSL  R22
	ROL  R23
	EOR  R23,R21
	LSL  R21
	ROR  R22
	RET

__CFD1U:
	SET
	RJMP __CFD1U0
__CFD1:
	CLT
__CFD1U0:
	PUSH R21
	RCALL __UNPACK1
	CPI  R23,0x80
	BRLO __CFD10
	CPI  R23,0xFF
	BRCC __CFD10
	RJMP __ZERORES
__CFD10:
	LDI  R21,22
	SUB  R21,R23
	BRPL __CFD11
	NEG  R21
	CPI  R21,8
	BRTC __CFD19
	CPI  R21,9
__CFD19:
	BRLO __CFD17
	SER  R30
	SER  R31
	SER  R22
	LDI  R23,0x7F
	BLD  R23,7
	RJMP __CFD15
__CFD17:
	CLR  R23
	TST  R21
	BREQ __CFD15
__CFD18:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	DEC  R21
	BRNE __CFD18
	RJMP __CFD15
__CFD11:
	CLR  R23
__CFD12:
	CPI  R21,8
	BRLO __CFD13
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R23
	SUBI R21,8
	RJMP __CFD12
__CFD13:
	TST  R21
	BREQ __CFD15
__CFD14:
	LSR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	DEC  R21
	BRNE __CFD14
__CFD15:
	TST  R0
	BRPL __CFD16
	RCALL __ANEGD1
__CFD16:
	POP  R21
	RET

__CDF1U:
	SET
	RJMP __CDF1U0
__CDF1:
	CLT
__CDF1U0:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __CDF10
	CLR  R0
	BRTS __CDF11
	TST  R23
	BRPL __CDF11
	COM  R0
	RCALL __ANEGD1
__CDF11:
	MOV  R1,R23
	LDI  R23,30
	TST  R1
__CDF12:
	BRMI __CDF13
	DEC  R23
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R1
	RJMP __CDF12
__CDF13:
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R1
	PUSH R21
	RCALL __REPACK
	POP  R21
__CDF10:
	RET

__SWAPACC:
	PUSH R20
	MOVW R20,R30
	MOVW R30,R26
	MOVW R26,R20
	MOVW R20,R22
	MOVW R22,R24
	MOVW R24,R20
	MOV  R20,R0
	MOV  R0,R1
	MOV  R1,R20
	POP  R20
	RET

__UADD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	RET

__NEGMAN1:
	COM  R30
	COM  R31
	COM  R22
	SUBI R30,-1
	SBCI R31,-1
	SBCI R22,-1
	RET

__SUBF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129
	LDI  R21,0x80
	EOR  R1,R21

	RJMP __ADDF120

__ADDF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129

__ADDF120:
	CPI  R23,0x80
	BREQ __ADDF128
__ADDF121:
	MOV  R21,R23
	SUB  R21,R25
	BRVS __ADDF129
	BRPL __ADDF122
	RCALL __SWAPACC
	RJMP __ADDF121
__ADDF122:
	CPI  R21,24
	BRLO __ADDF123
	CLR  R26
	CLR  R27
	CLR  R24
__ADDF123:
	CPI  R21,8
	BRLO __ADDF124
	MOV  R26,R27
	MOV  R27,R24
	CLR  R24
	SUBI R21,8
	RJMP __ADDF123
__ADDF124:
	TST  R21
	BREQ __ADDF126
__ADDF125:
	LSR  R24
	ROR  R27
	ROR  R26
	DEC  R21
	BRNE __ADDF125
__ADDF126:
	MOV  R21,R0
	EOR  R21,R1
	BRMI __ADDF127
	RCALL __UADD12
	BRCC __ADDF129
	ROR  R22
	ROR  R31
	ROR  R30
	INC  R23
	BRVC __ADDF129
	RJMP __MAXRES
__ADDF128:
	RCALL __SWAPACC
__ADDF129:
	RCALL __REPACK
	POP  R21
	RET
__ADDF127:
	SUB  R30,R26
	SBC  R31,R27
	SBC  R22,R24
	BREQ __ZERORES
	BRCC __ADDF1210
	COM  R0
	RCALL __NEGMAN1
__ADDF1210:
	TST  R22
	BRMI __ADDF129
	LSL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVC __ADDF1210

__ZERORES:
	CLR  R30
	CLR  R31
	CLR  R22
	CLR  R23
	POP  R21
	RET

__MINRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	SER  R23
	POP  R21
	RET

__MAXRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	LDI  R23,0x7F
	POP  R21
	RET

__MULF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BREQ __ZERORES
	CPI  R25,0x80
	BREQ __ZERORES
	EOR  R0,R1
	SEC
	ADC  R23,R25
	BRVC __MULF124
	BRLT __ZERORES
__MULF125:
	TST  R0
	BRMI __MINRES
	RJMP __MAXRES
__MULF124:
	PUSH R0
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R17
	CLR  R18
	CLR  R25
	MUL  R22,R24
	MOVW R20,R0
	MUL  R24,R31
	MOV  R19,R0
	ADD  R20,R1
	ADC  R21,R25
	MUL  R22,R27
	ADD  R19,R0
	ADC  R20,R1
	ADC  R21,R25
	MUL  R24,R30
	RCALL __MULF126
	MUL  R27,R31
	RCALL __MULF126
	MUL  R22,R26
	RCALL __MULF126
	MUL  R27,R30
	RCALL __MULF127
	MUL  R26,R31
	RCALL __MULF127
	MUL  R26,R30
	ADD  R17,R1
	ADC  R18,R25
	ADC  R19,R25
	ADC  R20,R25
	ADC  R21,R25
	MOV  R30,R19
	MOV  R31,R20
	MOV  R22,R21
	MOV  R21,R18
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	POP  R0
	TST  R22
	BRMI __MULF122
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	RJMP __MULF123
__MULF122:
	INC  R23
	BRVS __MULF125
__MULF123:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__MULF127:
	ADD  R17,R0
	ADC  R18,R1
	ADC  R19,R25
	RJMP __MULF128
__MULF126:
	ADD  R18,R0
	ADC  R19,R1
__MULF128:
	ADC  R20,R25
	ADC  R21,R25
	RET

__DIVF21:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BRNE __DIVF210
	TST  R1
__DIVF211:
	BRPL __DIVF219
	RJMP __MINRES
__DIVF219:
	RJMP __MAXRES
__DIVF210:
	CPI  R25,0x80
	BRNE __DIVF218
__DIVF217:
	RJMP __ZERORES
__DIVF218:
	EOR  R0,R1
	SEC
	SBC  R25,R23
	BRVC __DIVF216
	BRLT __DIVF217
	TST  R0
	RJMP __DIVF211
__DIVF216:
	MOV  R23,R25
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R1
	CLR  R17
	CLR  R18
	CLR  R19
	CLR  R20
	CLR  R21
	LDI  R25,32
__DIVF212:
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	CPC  R20,R17
	BRLO __DIVF213
	SUB  R26,R30
	SBC  R27,R31
	SBC  R24,R22
	SBC  R20,R17
	SEC
	RJMP __DIVF214
__DIVF213:
	CLC
__DIVF214:
	ROL  R21
	ROL  R18
	ROL  R19
	ROL  R1
	ROL  R26
	ROL  R27
	ROL  R24
	ROL  R20
	DEC  R25
	BRNE __DIVF212
	MOVW R30,R18
	MOV  R22,R1
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	TST  R22
	BRMI __DIVF215
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVS __DIVF217
__DIVF215:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__CMPF12:
	TST  R25
	BRMI __CMPF120
	TST  R23
	BRMI __CMPF121
	CP   R25,R23
	BRLO __CMPF122
	BRNE __CMPF121
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	BRLO __CMPF122
	BREQ __CMPF123
__CMPF121:
	CLZ
	CLC
	RET
__CMPF122:
	CLZ
	SEC
	RET
__CMPF123:
	SEZ
	CLC
	RET
__CMPF120:
	TST  R23
	BRPL __CMPF122
	CP   R25,R23
	BRLO __CMPF121
	BRNE __CMPF122
	CP   R30,R26
	CPC  R31,R27
	CPC  R22,R24
	BRLO __CMPF122
	BREQ __CMPF123
	RJMP __CMPF121

__CPW02:
	CLR  R0
	CP   R0,R26
	CPC  R0,R27
	RET

__CPD02:
	CLR  R0
	CP   R0,R26
	CPC  R0,R27
	CPC  R0,R24
	CPC  R0,R25
	RET

__CPD12:
	CP   R30,R26
	CPC  R31,R27
	CPC  R22,R24
	CPC  R23,R25
	RET

__CPD21:
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	CPC  R25,R23
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
