
#pragma used+
sfrb TWBR=0;
sfrb TWSR=1;
sfrb TWAR=2;
sfrb TWDR=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      
sfrb ADCSRA=6;
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   
sfrb UBRRH=0x20;
sfrb UCSRC=0X20;
sfrb WDTCR=0x21;
sfrb ASSR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrw ICR1=0x26;   
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb SFIOR=0x30;
sfrb OSCCAL=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TWCR=0x36;
sfrb SPMCR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb GIFR=0x3a;
sfrb GICR=0x3b;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#endasm

#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

#pragma used+

signed char cmax(signed char a,signed char b);
int max(int a,int b);
long lmax(long a,long b);
float fmax(float a,float b);
signed char cmin(signed char a,signed char b);
int min(int a,int b);
long lmin(long a,long b);
float fmin(float a,float b);
signed char csign(signed char x);
signed char sign(int x);
signed char lsign(long x);
signed char fsign(float x);
unsigned char isqrt(unsigned int x);
unsigned int lsqrt(unsigned long x);
float sqrt(float x);
float floor(float x);
float ceil(float x);
float fmod(float x,float y);
float modf(float x,float *ipart);
float ldexp(float x,int expon);
float frexp(float x,int *expon);
float exp(float x);
float log(float x);
float log10(float x);
float pow(float x,float y);
float sin(float x);
float cos(float x);
float tan(float x);
float sinh(float x);
float cosh(float x);
float tanh(float x);
float asin(float x);
float acos(float x);
float atan(float x);
float atan2(float y,float x);

#pragma used-
#pragma library math.lib

const float P2=6.283185308;
const float DR=0.017453293;
const float K1=0.262516090;

const unsigned char days_month[12]={31,28,31,30,31,30,31,31,30,31,30,31};
unsigned char  hr=0, mins=0, sec, day=1, B5=69, C0, H=3, lat=33, cor=30, M=3; 

long int J3, Y=2009;

long int MM[2], HH[2];

float aA[2], aD[2];

float D, T, T0, TT, A, B, A0, D0, D1, E, F, J, S, L, G, V, U, V0, V1, V2; 

bit M8, W8, st, change=0;

unsigned char time_mart, time_octb;

float Abs(float x)
{
return(x<0?-x:x);
}

int Sgn(float x)
{  
return(x>=0?1:-1);
}

long int Trunc (float x)
{
if (x>=0) {x=floor(x);}
else {x=ceil(x);}
return (long int)x;
}

void Calendar(void)
{
D1 = Trunc(D);
F = D - D1 - 0.5; 
J = -Trunc(1.75 * (Trunc((M + 9.0) / 12) + Y));                                      
S = Sgn(M - 9);
J3 = Trunc(Y + S * Trunc(Abs(M - 9)/7));
J3 =( -(((J3 / 100) + 1) * 0.75));
J = J + Trunc(30.555555556 * M ) + D1 + J3;
J = J + 1721029 + 367 * Y;
if (F >= 0) {return;};
F = F + 1;
J = J - 1;
}

void GetTimeZone(void)
{
S = 24110.5 + 236.555367912 * T;
S = S -(3609.858333333 * (float) H) + 240.0 * lat;
S = S / 86400;
S = S - Trunc(S);
T0 = S * 360 * DR;
} 

float GetAtan()
{
return atan(S / sqrt(1 - S * S));
}

void PosOfSun(char ind)
{

L = 0.779072 + 0.00273790931 * T;
G = 0.993126 + 0.0027377785 * T;
L = L - Trunc(L);
G = G - Trunc(G);
L = L * P2;
G = G * P2;
V = 0.39785 * sin(L);
V = V - 0.01000 * sin(L - G);
V = V + 0.00333 * sin(L + G);
V = V - 0.00021 * TT * sin(L);   
U = 1 - 0.03349 * cos(G);
U = U - 0.00014 * cos(2 * L);
U = U + 0.00008 * cos(L);      
S = -0.00010 - 0.04129 * sin(2 * L);
S = S + 0.03211 * sin(G);
S = S + 0.00104 * sin(2 * L - G);
S = S - 0.00035 * sin(2 * L + G);
S = S - 0.00008 * TT * sin(G);
S = S / sqrt(U - V * V);
aA[ind] = L + GetAtan();
S = V / sqrt(U);
aD[ind] = GetAtan();
}

float getV(float vd, float vh)
{
return (S * sin(vd) + cos(B5 * DR)* cos(vd) * cos(vh) - cos(DR * 90.833));
}

void PossibleEvents(int Hour)
{
L = aA[0] + ((float)Hour + 1) / 24 * (aA[1] - aA[0]);
G = aD[0] + ((float)Hour + 1) / 24 * (aD[1] - aD[0]);
st = 0;
A = T0 + Hour * K1 - A0;
B = T0 + Hour * K1 + K1 - L;
if (Hour <= 0) {V0 = getV(D0, A);}
V2 = getV(G,B);
if (Sgn(V0) == Sgn(V2)) {goto end2;}
V1 = getV((G + D0) / 2,(B + A) / 2);
A = 2 * V2 - 4 * V1 + 2 * V0;
B = 4 * V1 - 3 * V0 - V2;
D = B * B - 4 * A * V0;
if (D < 0) {goto end2;};
D = sqrt(D);
E = (-B + D) / (2 * A);
if ((E > 1) || (E < 0)) {E = (-B - D) / (2 * A);} 
A = (Hour + E + 1 / 120 );
B = Trunc((A - Trunc(A)) * 60); 
if ((V0 < 0) && (V2 > 0)) {HH[0]=Trunc(A);  MM[0]=Trunc(B);  M8 = 1; st=1;};
if ((V0 > 0) && (V2 < 0)) {HH[1]=Trunc(A);  MM[1]=Trunc(B);  W8 = 1; st=1;};
end2:   
A0 = L;
D0 = G;
V0 = V2;
}

void OutInform(void)
{
if ((M8 == 0) && (W8 == 0))
{  
if (V2 < 0) {st=1;}
if (V2 > 0) {st=0;}
}
else
{
if (M8 == 0) {st=1;} 
if (W8 == 0) {st=0;} 
}
}

char Get_Day(int _day, int _month)
{ 
int a, y, m; 
a = (14 - _month) / 12; 
y = Y - a; 
m = _month + 12 * a - 2; 
return (7000 + (_day + y + y / 4 - y / 100 + y / 400 + (31 * m) / 12)) % 7; 
};

void show_info(void)
{ 
D = day;
Calendar();
T = (J - 2451545) + F;
TT = T / 36525 + 1; 
GetTimeZone(); 
T = T - (float) H / 24;
PosOfSun(0); 
T = T + 1;
PosOfSun(1); 
if (aA[1] < aA[0]) {aA[1] = aA[1] + P2;}
S = sin(B5 * DR);
M8 = 0;
W8 = 0;
A0 = aA[0];
D0 = aD[0];
for (C0 = 0; C0 < 24; C0++) {PossibleEvents(C0);}
OutInform();
for (C0 = 25; C0 < 32; C0++)
{
if (Get_Day(C0,3)==0) {time_mart=C0;};
}
for (C0 = 25; C0 < 32; C0++)
{
if (Get_Day(C0,10)==0) {time_octb=C0;};
}
}

unsigned char Ok=27, Down=29, Up=30, key=31;

flash char digits[] = {       
0b00111111,                   
0b00000110,                   
0b01011011,                   
0b01001111,                   
0b01100110,                   
0b01101101,                   
0b01111101,                   
0b00000111,                   
0b01111111,                   
0b01101111,                   
0b00111000,                   
0b01010100,                   
0b01111000,                   
0b00111001,                   
0b01011100,                   
0b00110011,                   
0b00100111,                   
0b01110110,                   
0b01110111,                   
0b01010100,                   

0b01011110,                   
0b01110100,                   
0b01010000,                   
0b01000000,                   
0b10000000,                   
0b11110111                   
};

unsigned char digit_buff[4];

interrupt [10] void timer0_ovf_isr(void)
{

key=PINC & 0b00011111;
}

interrupt [5] void timer2_ovf_isr(void)
{

sec++; 
}

void me_delay(void)
{
while (key!=31) {key=PINC & 0b00011111; delay_ms(10);}; 
}

void display(void)
{ 
PORTB=0b00011100;
PORTD=digit_buff[0];
delay_ms(8);

PORTB=0b00011010;
PORTD=digit_buff[1];
delay_ms(8);

PORTB=0b00010110;
PORTD=digit_buff[2];
delay_ms(8);

PORTB=0b00001110;
PORTD=digit_buff[3];
delay_ms(8);  
}

void sun_up(void)
{
digit_buff[0]=digits[HH[0]/10%10];
digit_buff[1]=digits[HH[0]%10];
digit_buff[2]=digits[MM[0]/10%10];
digit_buff[3]=digits[MM[0]%10];
display(); 
}

void sun_dn(void)
{
digit_buff[0]=digits[HH[1]/10%10];
digit_buff[1]=digits[HH[1]%10];
digit_buff[2]=digits[MM[1]/10%10];
digit_buff[3]=digits[MM[1]%10];
display();
}

void recode_time(void) 
{       
digit_buff[0]=digits[(hr/10)%10];        
digit_buff[1]=digits[hr%10];     
digit_buff[2]=digits[(mins/10)%10];     
digit_buff[3]=digits[mins%10];    
} 

void sun_info()          
{ 

}

void clock(void)
{ unsigned char qty_days;

if (sec==60) 
{
sec=0; 
mins++; 
} else 
{
return; 
};
if (mins==60) {mins=0; hr++;};
if (hr==24) {day++; hr=0; show_info();};
qty_days=days_month[M-1];
if ((M==2) && (Y%4)==(Y/4)) {qty_days = 29;}
if (day>qty_days) {M++; day=1; change=0;};

if ((M==3) && (day==time_mart) && (change==0)) 
{                                                      
if (hr==1)                                           
{
hr++;                                              
change=1;                                          
}
};

if ((M==10) && (day==time_octb) && (change==0)) 
{                                                       
if (hr==1)                                            
{
hr--;                                               
change=1;                                           
}
};

if (M>12) {M=1; Y++;};
recode_time(); 
}

void on_of_led(void)
{  
long int time_dn, time_up, time_now;
time_up=(HH[0]*60 + MM[0]) - cor;
time_dn=(HH[1]*60 + MM[1]) + cor;
time_now=(long int)hr*60 + mins;
if (st==1) {PORTC.5=1;;} else
if ((time_now>=time_up)&&(time_now<=time_dn)) {PORTC.5=0;;}  
else {PORTC.5=1;;};

}

void keypress(unsigned char ind, long int ddey, int ga, int gb, char sw) 
{
while (key!=Ok)
{ 
if (sw==1)
{
digit_buff[2]=digits[ddey/10%10];
digit_buff[3]=digits[ddey%10];
display();
}
else 
{  
display();
} 
if ((key==Up) & (ddey<ga)) {ddey++; delay_ms(200);}
if ((key==Down) & (ddey>gb)) {ddey--; delay_ms(200);} 
if (ind==1) {}
if (ind==2) {B5=ddey;}   
if (ind==3) {lat=(float)ddey;}
if (ind==4) {M=ddey;}
if (ind==5) {day=ddey;}
if (ind==6) {Y=ddey;}
if (ind==7) {hr=ddey;}  
if (ind==8) {mins=ddey;} 
if (ind==9) {cor=ddey;}
if (ind==10) {H=ddey;} 
}
me_delay(); 
}

void menu(void)
{  
digit_buff[0]=digits[25]; 
digit_buff[1]=digits[12]; 
digit_buff[2]=digits[0]; 
digit_buff[3]=digits[3]; 
keypress(1,0,0,0,0);

digit_buff[0]=digits[10]; 
digit_buff[1]=digits[11]; 
keypress(2, B5, 90, 0, 1); 

digit_buff[0]=digits[10];  
digit_buff[1]=digits[12];  
keypress(3, lat, 180, 0, 1); 

digit_buff[0]=digits[15];    
digit_buff[1]=digits[16];    
keypress(4, M, 12, 1, 1); 

digit_buff[0]=digits[20];     

digit_buff[1]=digits[11];    
keypress(5, day, days_month[M-1], 1, 1); 

digit_buff[0]=digits[2];    
digit_buff[1]=digits[0];    
keypress(6, Y, 2100, 2000, 1); 

digit_buff[0]=digits[21];   
digit_buff[1]=digits[22];   
keypress(7, hr, 23, 0, 1); 

digit_buff[0]=digits[19];   
digit_buff[1]=digits[19];   
keypress(8, mins, 59, 0, 1); 

digit_buff[0]=digits[13];   
digit_buff[1]=digits[14];   
keypress(9, cor, 59, 0, 1);  

digit_buff[0]=digits[2];    
digit_buff[1]=digits[11];   
keypress(10, H, 12, 0, 1);

sec=0;
change=0; 
display();
}

void main(void)
{

PORTB=0x00;
DDRB=0x1E;

PORTC=0x1F;
DDRC=0x20;

PORTD=0x00;
DDRD=0xFF;

TCCR0=0x04;
TCNT0=0x00;

TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x1E;
OCR1AL=0x85;
OCR1BH=0x00;
OCR1BL=0x00;

ASSR=0x08;
TCCR2=0x05;
TCNT2=0x00;
OCR2=0x00;

MCUCR=0x00;

TIMSK=0x41;

ACSR=0x80;
SFIOR=0x00;

#asm("sei")

me_delay();

menu();      
show_info();
recode_time();    
display();

while (1)
{

if (key !=31) {me_delay(); menu(); show_info();};
clock();
recode_time();
display(); 
on_of_led();
while (key==Up) {sun_up();};
while (key==Down) {sun_dn();};
};
}
